<?php
/***************************************************************************
 *                            functions_admin.php
 *                            -------------------
 *   begin                : Sunday, Mar 31, 2002
 *   copyright            : (C) 2002 Meik Sievertsen
 *   email                : acyd.burn@gmx.de
 *
 *   $Id: functions_admin.php,v 2.2.1 2002/04/13 meik Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

//
// All Attachment Functions only needed in Admin
//

//
// sort multi-dimensional Array
//
function sort_multi_array ($sort_array, $key, $sort_order) 
{
	$last_element = count($sort_array) - 1;

	$string_sort = ( is_string($sort_array[$last_element-1][$key]) ) ? TRUE : FALSE;

	for ($i = 0; $i < $last_element; $i++) 
	{
		$num_iterations = $last_element - $i;

		for ($j = 0; $j < $num_iterations; $j++) 
		{
			$next = 0;

			//
			// do checks based on key
			//
			$switch = FALSE;
			if ( !($string_sort) )
			{
				if ( ( ($sort_order == "DESC") && (intval($sort_array[$j][$key]) < intval($sort_array[$j + 1][$key])) ) || ( ($sort_order == "ASC") &&    (intval($sort_array[$j][$key]) > intval($sort_array[$j + 1][$key])) ) )
				{
					$switch = TRUE;
				}
			}
			else
			{
				if ( ( ($sort_order == "DESC") && (strcasecmp($sort_array[$j][$key], $sort_array[$j + 1][$key]) < 0) ) || ( ($sort_order ==   "ASC") && (strcasecmp($sort_array[$j][$key], $sort_array[$j + 1][$key]) > 0) ) )
				{
					$switch = TRUE;
				}
			}

			if ($switch)
			{
				$temp = $sort_array[$j];
				$sort_array[$j] = $sort_array[$j + 1];
				$sort_array[$j + 1] = $temp;
			}
		}
	}

	return ($sort_array);
}

//
// See if a post_id really exist
//
function post_exists($post_id, $privmsgs_text_id)
{
	global $db;

	if ($post_id != 0)
	{
		$sql = "SELECT post_id
		FROM " . POSTS_TABLE . "
		WHERE post_id = " . $post_id;
	}
	else
	{
		$sql = "SELECT privmsgs_id
		FROM " . PRIVMSGS_TABLE . "
		WHERE privmsgs_id = " . $privmsgs_text_id;
	}

	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Could not get post", "", __LINE__, __FILE__, $sql);
	}
	
	if( ( $db->sql_numrows($result) ) > 0 )
	{
		return (TRUE);
	}

	return (FALSE);
}

//
// Collect all Attachments in Filesystem
//
function collect_attachments()
{
	global $upload_dir, $attach_config;

	$file_attachments = array(); 

	if (!$attach_config['allow_ftp_upload'])
	{
		$dir = opendir($upload_dir);

		while($file = readdir($dir))
		{
			if( ($file != 'index.php') && ($file != '.htaccess') && (!is_dir($upload_dir . '/' . $file)) && (!is_link($upload_dir . '/' . $file)) )
			{
				$file_attachments[] = $file;
			}
		}
	
		closedir($dir);


/*
		$upload_thumb = "$upload_dir/thumb";		
		$dir = opendir($upload_thumb);

		while($file = readdir($dir))
		{
			if( ($file != 'index.php') && ($file != '.htaccess') && (!is_dir($upload_thumb . '/' . $file)) && (!is_link($upload_thumb . '/' . $file)) )
			{
				$file_attachments[] = "thumb/" . "$file";
			}
		}
	
		closedir($dir);
*/




	}
	else
	{
		$conn_id = attach_init_ftp();

		$file_listing = array();

		$file_listing = @ftp_rawlist($conn_id, './');

		for ($i = 0; $i < count($file_listing); $i++)
		{
			if (ereg("([-d])[rwxst-]{9}.* ([0-9]*) ([a-zA-Z]+[0-9: ]*[0-9]) ([0-9]{2}:[0-9]{2}) (.+)", $file_listing[$i], $regs) )
			{
				if ($regs[1] == 'd') 
				{	
					$dirinfo[0] = 1;	// Directory == 1
				}
				$dirinfo[1] = $regs[2]; // Size
				$dirinfo[2] = $regs[3]; // Date
				$dirinfo[3] = $regs[4]; // Filename
				$dirinfo[4] = $regs[5]; // Time
			}
			
			if ( ($dirinfo[0] != 1) && ($dirinfo[4] != 'index.php') && ($dirinfo[4] != '.htaccess') )
			{
				$file_attachments[] = $dirinfo[4];
			}
		}

		@ftp_quit($conn_id);
	}

	return ($file_attachments);
}

//
// Returns the filesize of the upload directory in human readable format
//
function get_formatted_dirsize()
{
	global $attach_config, $upload_dir, $lang;

	$upload_dir_size = 0;

	if (!$attach_config['allow_ftp_upload'])
	{
	
		if ($dirname = @opendir($upload_dir))
		{
			while( $file = @readdir($dirname) )
			{
				if( ($file != 'index.php') && ($file != '.htaccess') && (!is_dir($upload_dir . '/' . $file)) && (!is_link($upload_dir . '/' . $file)) )
				{
					$upload_dir_size += @filesize($upload_dir . '/' . $file);
				}
			}
			@closedir($dirname);
		}
		else
		{
			$upload_dir_size = $lang['Not_available'];
			return ($upload_dir_size);
		}
	}
	else
	{
		$conn_id = attach_init_ftp();

		$file_listing = array();

		$file_listing = @ftp_rawlist($conn_id, './');

		if (!$file_listing)
		{
			$upload_dir_size = $lang['Not_available'];
			return ($upload_dir_size);
		}

		for ($i = 0; $i < count($file_listing); $i++)
		{
			if (ereg("([-d])[rwxst-]{9}.* ([0-9]*) ([a-zA-Z]+[0-9: ]*[0-9]) ([0-9]{2}:[0-9]{2}) (.+)", $file_listing[$i], $regs) )
			{
				if ($regs[1] == 'd') 
				{	
					$dirinfo[0] = 1;	// Directory == 1
				}
				$dirinfo[1] = $regs[2]; // Size
				$dirinfo[2] = $regs[3]; // Date
				$dirinfo[3] = $regs[4]; // Filename
				$dirinfo[4] = $regs[5]; // Time
			}
			
			if ( ($dirinfo[0] != 1) && ($dirinfo[4] != 'index.php') && ($dirinfo[4] != '.htaccess') )
			{
				$upload_dir_size += $dirinfo[1];
			}
		}

		@ftp_quit($conn_id);
	}

	if($upload_dir_size >= 1048576)
	{
		$upload_dir_size = round($upload_dir_size / 1048576 * 100) / 100 . ' ' . $lang['MB'];
	}
	else if($upload_dir_size >= 1024)
	{
		$upload_dir_size = round($upload_dir_size / 1024 * 100) / 100 . ' ' . $lang['KB'];
	}
	else
	{
		$upload_dir_size = $upload_dir_size . ' ' . $lang['Bytes'];
	}

	return ($upload_dir_size);
}

//
// Build SQL-Statement for the search feature
//
function search_attachments($order_by)
{
	global $db, $HTTP_POST_VARS, $HTTP_GET_VARS, $lang;
	
	$where_sql = array();

	//
	// Get submitted Vars
	//
	$search_vars = array('search_keyword_fname', 'search_keyword_comment', 'search_author', 'search_size_smaller', 'search_size_greater', 'search_count_smaller', 'search_count_greater', 'search_days_greater', 'search_forum', 'search_cat');
	
	for ($i = 0; $i < count($search_vars); $i++)
	{
		if( isset($HTTP_POST_VARS[$search_vars[$i]]) || isset($HTTP_GET_VARS[$search_vars[$i]]) )
		{
			$$search_vars[$i] = ( isset($HTTP_POST_VARS[$search_vars[$i]]) ) ? $HTTP_POST_VARS[$search_vars[$i]] : $HTTP_GET_VARS[$search_vars[$i]];
		}
		else
		{
			$$search_vars[$i] = '';
		}
	}

	//
	// Author name search 
	//
	if ( $search_author != '')
	{
		$search_author = str_replace('*', '%', trim(str_replace("\'", "''", $search_author)));

		//
		// We need the post_id's, because we want to query the Attachment Table
		//
		$sql = "SELECT user_id
		FROM " . USERS_TABLE . "
		WHERE username LIKE '" . $search_author . "'";

		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, "Couldn't obtain list of matching users (searching for: $search_author)", "", __LINE__, __FILE__, $sql);
		}

		$matching_userids = '';
		if ( $row = $db->sql_fetchrow($result) )
		{
			do
			{
				$matching_userids .= ( ( $matching_userids != '' ) ? ', ' : '' ) . $row['user_id'];
			}
			while( $row = $db->sql_fetchrow($result) );
		}
		else
		{
			message_die(GENERAL_MESSAGE, $lang['No_attach_search_match']);
		}

		$sql = "SELECT post_id 
		FROM " . POSTS_TABLE . " 
		WHERE poster_id IN ($matching_userids)";

		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, "Couldn't obtain matched posts list", "", __LINE__, __FILE__, $sql);
		}

		$matching_postids = '';
		if ( $row = $db->sql_fetchrow($result) )
		{
			do
			{
				$matching_postids .= ( ( $matching_postids != '' ) ? ', ' : '' ) . $row['post_id'];
			}
			while( $row = $db->sql_fetchrow($result) );
		}
		else
		{
			message_die(GENERAL_MESSAGE, $lang['No_attach_search_match']);
		}

		$where_sql[] = ' (t.post_id IN (' . $matching_postids . ')) ';
	}

	//
	// Search Keyword
	//
	if ( $search_keyword_fname != '' )
	{
		$match_word = str_replace('*', '%', $search_keyword_fname);
		$where_sql[] = " (a.filename LIKE '" . $match_word . "') ";
	}

	if ( $search_keyword_comment != '' )
	{
		$match_word = str_replace('*', '%', $search_keyword_comment);
		$where_sql[] = " (a.comment LIKE '" . $match_word . "') ";
	}

	//
	// Search Download Count
	//
	if ( $search_count_smaller != '' || $search_count_greater != '' )
	{
		if ($search_count_smaller != '')
		{
			$where_sql[] = " (a.download_count < " . $search_count_smaller . ") ";
		}
		else if ($search_count_greater != '')
		{
			$where_sql[] = " (a.download_count > " . $search_count_greater . ") ";
		}
	}

	//
	// Search Filesize
	//
	if ( $search_size_smaller != '' || $search_size_greater != '' )
	{
		if ($search_size_smaller != '')
		{
			$where_sql = " (a.filesize < " . $search_size_smaller . ") ";
		}
		else if ($search_size_greater != '')
		{
			$where_sql = " (a.filesize > " . $search_size_greater . ") ";
		}
	}

	//
	// Search Attachment Time
	//
	if ( $search_days_greater != '' )
	{
		$where_sql = " (a.filetime < " . time() - ( $search_days_greater * 86400 ) . ") ";
	}

	$sql = "SELECT a.*, t.*, p.post_time, p.topic_id, a.attach_id
	FROM " . ATTACH_TABLE . " t, " . ATTACH_DESC_TABLE . " a, " . POSTS_TABLE . " p WHERE ";
	
	if (count($where_sql) > 0)
	{
		$sql .= implode('AND', $where_sql) . ' AND ';
	}

	$sql .= '(t.post_id = p.post_id) GROUP BY a.attach_id ' . $order_by;

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't query attachments", "", __LINE__, __FILE__, $sql);
	}

	if ( ($db->sql_numrows($result)) > 0 )
	{
		$attachments = $db->sql_fetchrowset($result);

		for ($i = 0; $i < count($attachments); $i++)
		{
			$types = explode('/', $attachments[$i]['mimetype']);
			$attachments[$i]['mimetype'] = $types[1];
			$attachments[$i]['mimegroup'] = $types[0];
		}
	}
	
	if (count($attachments) == 0)
	{
		message_die(GENERAL_MESSAGE, $lang['No_attach_search_match']);
	}

	return ($attachments);
}

//
// perform LIMIT statement on arrays
//
function limit_array($array, $start, $pagelimit)
{
	//
	// array from start - start+pagelimit
	//
	$limit = ( count($array) < $start + $pagelimit ) ? count($array) : $start + $pagelimit;

	$limit_array = array();

	for ($i = $start; $i < $limit; $i++)
	{
		$limit_array[] = $array[$i];
	}

	return $limit_array;
}

?>