<?php
/***************************************************************************
 *                            functions_attach.php
 *                            -------------------
 *   begin                : Friday, Mar 29, 2002
 *   copyright            : (C) 2002 Meik Sievertsen
 *   email                : acyd.burn@gmx.de
 *
 *   $Id: functions_attach.php,v 2.2.1 2002/04/19 meik Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

//
// All Attachment Functions needed everywhere
//

//
// Init FTP Session
//
function attach_init_ftp()
{
	global $lang, $attach_config;

	$conn_id = @ftp_connect('localhost');

	if (!$conn_id)
	{
		message_die(GENERAL_ERROR, sprintf($lang['Ftp_error_connect'], 'localhost'));
	}

	$login_result = @ftp_login($conn_id, $attach_config['ftp_user'], $attach_config['ftp_pass']);

	if ( (!$login_result) )
	{
		message_die(GENERAL_ERROR, sprintf($lang['Ftp_error_login'], $attach_config['ftp_user']));
	}
		
	$result = @ftp_chdir($conn_id, $attach_config['ftp_path']);

	if (!$result)
	{
		message_die(GENERAL_ERROR, sprintf($lang['Ftp_error_path'], $attach_config['ftp_path']));
	}

	return ($conn_id);
}

//
// Deletes an Attachment
//
function unlink_attach($filename)
{
	global $upload_dir, $attach_config, $lang;

	if (!$attach_config['allow_ftp_upload'])
	{


		$real_file = $filename;
		$filename = $upload_dir . '/' . $filename;

		$deleted = @unlink($filename);

		if (@file_exists($filename) ) 
		{
			$filesys = eregi_replace('/','\\', $filename);
			$deleted = @system("del $filesys");

			if (@file_exists($filename)) 
			{
				$deleted = @chmod ($filename, 0775);
				$deleted = @unlink($filename);
				$deleted = @system("del $filesys");
			}
		}
		
		#ϵ 
		$exec_name = substr(strrchr(strtolower($real_file),"."),1); // Ȯ  
		$file_check = file_exists("$upload_dir/thumb/$real_file");
		if(eregi("^(jpg|jpeg)$",$exec_name) and $file_check ) { 
			$filename = $upload_dir . '/thumb/' . $real_file;
			$deleted = @unlink($filename);
			if (@file_exists($filename) ) 
			{
				$filesys = eregi_replace('/','\\', $filename);
				$deleted = @system("del $filesys");

				if (@file_exists($filename)) 
				{
					$deleted = @chmod ($filename, 0775);
					$deleted = @unlink($filename);
					$deleted = @system("del $filesys");
				}
			}
		}

		#ūϵ 
		$exec_name = substr(strrchr(strtolower($real_file),"."),1); // Ȯ  
		$file_check = file_exists("$upload_dir/large_thumb/$real_file");
		if(eregi("^(jpg|jpeg)$",$exec_name) and $file_check ) { 
			$filename = $upload_dir . '/large_thumb/' . $real_file;
			$deleted = @unlink($filename);
			if (@file_exists($filename) ) 
			{
				$filesys = eregi_replace('/','\\', $filename);
				$deleted = @system("del $filesys");

				if (@file_exists($filename)) 
				{
					$deleted = @chmod ($filename, 0775);
					$deleted = @unlink($filename);
					$deleted = @system("del $filesys");
				}
			}
		}



	}
	else
	{
		$conn_id = attach_init_ftp();

		$res = @ftp_delete($conn_id, $filename);

		if (!$res)
		{
			message_die(GENERAL_ERROR, sprintf($lang['Ftp_error_delete'], $attach_config['ftp_path']));
		}

		@ftp_quit($conn_id);

		$deleted = TRUE;
	}

	return ($deleted);
}

//
// Check if Attachment exist
//
function attachment_exists($filename)
{
	global $upload_dir, $attach_config;

	if (!$attach_config['allow_ftp_upload'])
	{
		if( !@file_exists($upload_dir . '/' . $filename) )
		{
			return (FALSE);
		}
		else
		{
			return (TRUE);
		}
	}
	else
	{
		$found = FALSE;

		$conn_id = attach_init_ftp();

		$file_listing = array();

		$file_listing = @ftp_rawlist($conn_id, $filename);

		for ($i = 0; $i < count($file_listing); $i++)
		{
			if (ereg("([-d])[rwxst-]{9}.* ([0-9]*) ([a-zA-Z]+[0-9: ]*[0-9]) ([0-9]{2}:[0-9]{2}) (.+)", $file_listing[$i], $regs) )
			{
				if ($regs[1] == 'd') 
				{	
					$dirinfo[0] = 1;	// Directory == 1
				}
				$dirinfo[1] = $regs[2]; // Size
				$dirinfo[2] = $regs[3]; // Date
				$dirinfo[3] = $regs[4]; // Filename
				$dirinfo[4] = $regs[5]; // Time
			}
			
			if ( ($dirinfo[0] != 1) && ($dirinfo[4] == $filename) )
			{
				$found = TRUE;
			}
		}

		@ftp_quit($conn_id);	
		
		return ($found);
	}
}

//
// get all attachments from one post or privmsgs
//
function get_attachments_from_post($post_id, $page = -1)
{
	global $db;

	$attachments = array();

	if ($page == PAGE_PRIVMSGS)
	{
		$sql_id = 'privmsgs_id';
	}
	else
	{
		$sql_id = 'post_id';
	}
	
	$sql = 'SELECT attach_id
	FROM ' . ATTACH_TABLE . '
	WHERE ' . $sql_id . ' = ' . $post_id;

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Could not get attachment informations for specific posts", "", __LINE__, __FILE__, $sql);
	}

	if ( ($db->sql_numrows($result)) == 0 )
	{
		return ($attachments);
	}
		
	$rows = $db->sql_fetchrowset($result);
	$attach_id_sql = array();

	for ($i = 0; $i < count($rows); $i++)
	{
		$attach_id_sql[] = $rows[$i]['attach_id'];
	}

	$attach_id_sql = implode(', ', $attach_id_sql);

	$sql = "SELECT *
	FROM " . ATTACH_DESC_TABLE . "
	WHERE attach_id IN (" . $attach_id_sql . ")
	ORDER BY filetime DESC";

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Could not get attachment informations for specific posts", "", __LINE__, __FILE__, $sql);
	}

	if ( ($db->sql_numrows($result)) == 0 )
	{
		return ($attachments);
	}
		
	$attachments = $db->sql_fetchrowset($result);
		
	return ($attachments);
}


?>