<?php
/***************************************************************************
 *                            functions_selects.php
 *                            -------------------
 *   begin                : Saturday, Mar 30, 2002
 *   copyright            : (C) 2002 Meik Sievertsen
 *   email                : acyd.burn@gmx.de
 *
 *   $Id: functions_selects.php,v 2.2.0 2002/03/30 meik Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

//
// Functions to build select boxes ;)
//

function group_select($select_name, $default_group = -1)
{
	global $db;
		
	$sql = "SELECT type_id, type_name
	FROM " . ATTACH_TYPES_TABLE . "
	ORDER BY type_name";

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't query types table", "", __LINE__, __FILE__, $sql);
	}

	$group_select = '<select name="' . $select_name . '">';

	if ( ($db->sql_numrows($result)) > 0 )
	{
		$group_name = $db->sql_fetchrowset($result);
	
		for($i = 0; $i < count($group_name); $i++)
		{

			if ( ($default_group == -1) )
			{
				$selected = ($i == 0) ? ' selected="selected"' : '';
			}
			else
			{
				$selected = ( $group_name[$i]['type_id'] == $default_group ) ? ' selected="selected"' : '';
			}

			$group_select .= '<option value="' . $group_name[$i]['type_id'] . '"' . $selected . '>' . $group_name[$i]['type_name'] . '</option>';
		}
	}

	$group_select .= '</select>';

	return($group_select);
}

function download_select($select_name, $type_id = -1)
{
	global $db, $types_download, $modes_download;
		
	if ($type_id != -1)
	{
		$sql = "SELECT download_mode
		FROM " . ATTACH_TYPES_TABLE . "
		WHERE type_id = " . $type_id;

		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, "Couldn't query types table", "", __LINE__, __FILE__, $sql);
		}
	
		$row = $db->sql_fetchrow($result);

		if ( count($row) == 0 )
		{
			return ('');
		}

		$download_mode = $row['download_mode'];
	}

	$group_select = '<select name="' . $select_name . '">';

	for ($i = 0; $i < count($types_download); $i++)
	{
		if ($type_id == -1)
		{
			$selected = ( $types_download[$i] == INLINE_LINK ) ? ' selected="selected"' : '';
		}
		else
		{
			$selected = ( $row['download_mode'] == $types_download[$i] ) ? ' selected="selected"' : '';
		}

		$group_select .= '<option value="' . $types_download[$i] . '"' . $selected . '>' . $modes_download[$i] . '</option>';
	}

	$group_select .= '</select>';

	return($group_select);
}

function category_select($select_name, $type_id = -1)
{
	global $db, $types_category, $modes_category;
		
	$sql = "SELECT type_id, category
	FROM " . ATTACH_TYPES_TABLE;

	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't query types table", "", __LINE__, __FILE__, $sql);
	}
	
	$rows = $db->sql_fetchrowset($result);
	$cats = array();
	$type_category = -1;

	if ( ($db->sql_numrows($result)) > 0 )
	{
		for($i = 0; $i < count($rows); $i++)
		{
			$cats['type_id'][] = $rows[$i]['type_id'];
			$cats['category'][] = $rows[$i]['category'];
			
			if ($type_id == $rows[$i]['type_id'])
			{
				$category_type = $rows[$i]['category'];
			}
		}
	}

	//
	// Prevent Selection of already existing categories
	//
	$types = array(NONE_CAT);
	$modes = array('none');

	if ($type_id == -1)
	{
		// evaluate all categories and add only those not defined
		for ($i = 0; $i < count($types_category); $i++)
		{
			if (!in_array($types_category[$i], $cats['category']))
			{
				$types[] = $types_category[$i];
				$modes[] = $modes_category[$i];
			}
		}
	}
	else
	{
		//
		// evaluate all categories and add only those not defined
		//
		for ($i = 0; $i < count($types_category); $i++)
		{
			if (!in_array($types_category[$i], $cats['category']))
			{
				$types[] = $types_category[$i];
				$modes[] = $modes_category[$i];
			}

			if ($category_type == $types_category[$i])
			{
				$types[] = $category_type;
				$modes[] = $modes_category[$i];
			}
		}

	}
	
	$group_select = '<select name="' . $select_name . '" style="width:100px">';

	for($i = 0; $i < count($types); $i++)
	{
		if ($type_id == -1)
		{
			$selected = ( $types[$i] == NONE_CAT ) ? ' selected="selected"' : '';
		}
		else
		{
			$selected = ( $types[$i] == $category_type ) ? ' selected="selected"' : '';
		}

		$group_select .= '<option value="' . $types[$i] . '"' . $selected . '>' . $modes[$i] . '</option>';
	}

	$group_select .= '</select>';

	return($group_select);
}

function size_select($select_name, $size_compare)
{
	global $lang;

	$size_types_text = array($lang['Bytes'], $lang['KB'], $lang['MB']);
	$size_types = array('b', 'kb', 'mb');

	$select_field = '<select name="' . $select_name . '">';

	for ($i = 0; $i < count($size_types_text); $i++)
	{
		$selected = ($size_compare == $size_types[$i]) ? ' selected="selected"' : '';

		$select_field .= '<option value="' . $size_types[$i] . '"' . $selected . '>' . $size_types_text[$i] . '</option>';
	}
	
	$select_field .= '</select>';

	return ($select_field);
}
