<?
/*###############################################################
## Mod Title: phpBB2 Calendar
## Mod Version: 1.2.2h (WebSnail.mod)
## Author: 1.0.1->:   WebSnail < info@snailsource.com >
## Original Author: Matthew D. Sluss < mds@isparian.com >
## Description: Add a Calendar to your phpBB2 installation!
##              All registerd and logged in users can post to the calendar
##              And Admins can modify, remove, add also.
##
## Installation Level: MEDIUM
## Installation Time: 5 minutes
## Files to Edit: 2 
## Files to Execute: 1(?) Dependent on upgrade/install of previous version. 
##
## Version Information: 1.2.2h - WebSnail < info@snailsource.com > 23-Apr-2002
## - BugFix: Removed extra slashes from "modify events" function.
## - Language: Updated Dutch translation < Joepsel >
## - Inclusion of "filehistory.txt" file to help with easier update tracking.
##
## Version Information: 1.2.2g - WebSnail < info@snailsource.com > 23-Apr-2002
## - BugFix: month value was failing to pass properly owing to missing '&'
##	    Was resulting in next/previous date reverting to December.
##
## Version Information: 1.2.2f - WebSnail < info@snailsource.com > 18-Apr-2002
## - BugFix: Text now displays the default language properly for logged off 
##	    users
## - BugFix: Added ';' line terminators to Spanish 'lang_calendar.php' file
## - Language: Added Dutch translation < Joepsel >
##	    NB: this will be updated shortly so check Forum for new version
##	    
##
## Version Information: 1.2.2e - WebSnail < info@snailsource.com > 18-Apr-2002
## - BugFix: Session code for sites where Cookies are "off" will now work
##	    NB: This will also allow browsers with cookies turned off to 
##	    access your Calendar
## - BugFix: Visitors not logged in will now see Language text.
## - BugFix: Stops pending group members from having groups calendar rights.
## - Language Field Added: the word "Calendar" is now included in the 
##	    translations (please could people check I got it right!)
## - Language: Added Italian translation < CereS >
## - Language: Added Spanish translation < CereS >
##
##
## Version Information: 1.2.2d - WebSnail < hacks@websnail.net > 05-Apr-2002
## - Feature: Language files created as separate calls dependant on users
##	      'user_lang' setting. Defaults to English.
##	      NB: Remember to copy the new 'lang_calendar.php' files to the
##	      correct directories or it won't work. Old lang_main.php edits
##	      can now be scrapped :)
## - Language: Added Chinese_traditional_taiwan (Big5) translation < Peigs >
## - Language: Added Portuguese translation < Underspell >
##
## Version Information: 1.2.2c - WebSnail < hacks@websnail.net > 21-Mar-2002
## - BugFix: Removed some test code that I left in Modify()... Doh!!!
##
## Version Information: 1.2.2b - WebSnail < hacks@websnail.net > 21-Mar-2002
## - BugFix: Fixes issue where "add event" button would appear when only one
##		$caluser group existed.
##
## Version Information: 1.2.2a - WebSnail < hacks@websnail.net > 21-Mar-2002
## - Feature: Date formatting introduced. Uses users selected date format by
##	      default. Can be overridden by $dateoverride in cal_settings.php
##
##
## Version Information: 1.2.1f - WebSnail < hacks@websnail.net > 20-Mar-2002
## - BugFix: CVS/RC4 change post.php to functions_post.php 
##	    [god these guys like to keep me on my toes!]
##
##
##
## NOTE: Please read Calendar-README.txt for version information
#################################################################
*/

// Set $phpbb_root_path to location of phpBB2 root directory.
$phpbb_root_path = "./";

// MAKE SURE YOU READ "INSTALL.txt" Re: changes to $mysql_tablename!!!

// Variable settings broken out of main script into separate file
// Provides easier access for Calendar reliant MOD's

include_once($phpbb_root_path . 'cal_settings.php');

/*##########################################
##                 STOP                    #
## DO NOT MODIFY ANYTHING BELOW THIS LINE  #
##########################################*/

$cal_version = "1.2.2g";
$cal_lang_file = "lang_calendar.php";


// Added with changes in Security for PhpBB2.
define('IN_PHPBB', true);

// connect to phpbb
include_once($phpbb_root_path . 'extension.inc');
include_once($phpbb_root_path . 'common.'.$phpEx);
include_once($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include_once($phpbb_root_path . 'includes/functions.'.$phpEx);

// Start session management
$userdata = session_pagestart($user_ip, PAGE_INDEX, $session_length);
init_userprefs($userdata);

// ADDED: ver 1.2.2d - (Language files)
// BugFix: ver 1.2.2e (fixed issue with non members getting no language)
// Replace lang file editing with language file calls.

if($board_config['default_lang']) {
	$langfile = $phpbb_root_path .'language/lang_'. $board_config['default_lang'] .'/'. $cal_lang_file;
	}
$langdefault = $phpbb_root_path .'language/lang_english/'. $cal_lang_file;

if (($userdata) && (file_exists($langfile))) { 
	include_once($langfile); 
	}
elseif (file_exists($langdefault)) {
	include_once($langdefault);
	}
else {
	echo "ERROR: Language files have not been installed correctly\n";
	echo "Please refer to the 'README' file for Calendar";
	exit;
	}


// END ADDED


// ADDED ver 1.0.7 (Tablename standardised)
if (!$mysql_tablename) {
	$mysql_tablename = $table_prefix . $tablename;
	}
// END ADDED

// MOD ver 1.2.1d
// Interim days id to help with transfer to $lang['datetime'] format.
// DO NOT CHANGE THESE!!!!!!!!!!!!!!!!
$langdays[0] = $lang['datetime']['Sunday'];
$langdays[1] = $lang['datetime']['Monday'];
$langdays[2] = $lang['datetime']['Tuesday'];
$langdays[3] = $lang['datetime']['Wednesday'];
$langdays[4] = $lang['datetime']['Thursday'];
$langdays[5] = $lang['datetime']['Friday'];
$langdays[6] = $lang['datetime']['Saturday'];
// End change for 1.2.1d

// Make sure there's a Default for $daycolor
if(!$daycolor) { $daycolor = '#FFFFFF'; }

$test = $userdata[user_id];
$caluser = calendaruser($test);
$calmod = calendarmod($test);
if ($calmod == 'yes') { $caluser = 'yes'; }
if ($userdata[user_level] == 1)
	{
	$calmod = 'yes';
	$caluser = 'yes';
	}

// MOD 1.1.0

if ( $userdata['session_logged_in'] ) 
	{ 
	$lvd = sprintf($lang['You_last_visit'], create_date($board_config['default_dateformat'], $userdata['user_lastvisit'], $board_config['board_timezone'])); 
	} 
else 
	{ 
	$lvd = "Not Logged In"; 
	} 

include ($phpbb_root_path . "includes/page_header.php"); 

$ct = sprintf($lang['Current_time'], create_date($board_config['default_dateformat'], time(), 
		$board_config['board_timezone'])); 

$Idx = sprintf($lang['Forum_Index'], $board_config['sitename']); 

if ($showheaders == 'yes') 
	{ 
	echo "<font size=1>"; 
	echo"$lvd"; 
	echo"<br>"; 
	echo"$ct"; 
	echo"<br><br>"; 
	echo"</font>"; 
	}
// MOD 1.1.0 End

// echo"<body bgcolor=white text=black><center>";
echo "<table width=100% cellpadding=0 border=0 cellspacing=0><tr>";

// MOD 1.1.0 : Added Header info'
if ($showheaders == 'yes') 
	{ 
	echo "<td><a href='index.php' class=nav>$Idx</a><br></td>"; 
	}
// MOD 1.1.0 : End Add Header info'

echo "<td align=right class=genmed>Version $cal_version</td></tr>
        </table>\n";
echo "<table width=100% cellpadding=0 border=1 cellspacing=2 style=\"border-collapse:collapse; border-color: black\">
       <tr><th>\n";

// MOD ver 1.0.8 : allows Admin choice of whether to allow anon access to calendar or not
$denyaccess = '';
if (($allowanonview != 'yes') && ($userdata && $userdata[user_id] == '-1') || (!$userdata))
	{
	print ($lang['Cal_not_enough_access']);
	echo "$day $monthname $year</th></tr><tr><Td class=genmed>";
	print ($lang['Cal_must_member']);
	$denyaccess = 'yes';
	}
// End MOD ver 1.0.8

if (($mode == 'modify') && (!$denyaccess)) { modify(); }
elseif (($mode == 'validate') && (!$denyaccess)) { validate(); }
elseif (($mode == 'operate') && (!$denyaccess)) { operate(); }
elseif (($mode == 'display') && (!$denyaccess)) { display(); }
elseif (!$denyaccess) { defaultview($todaycolor); }

include_once($phpbb_root_path . 'includes/page_tail.php');
if ($config_footer == YES)
include ("$footer");
exit;

function modify()
{
   	global $PHP_SELF, $board_config, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action, $lastday,
		$id, $day, $month, $year, $time, $userdata, $lang, $config_footer, $footer, $calmod, $caluser,
		$endday, $endmonth, $endyear, $usersuggest, $allowold;

   	// $monthname = $lang['months_long'][date('n', mktime(0,0,0,$month,1,$year))-1];
	// v1.2.1.c Replaced with CVS friendly version following change to $lang['datetime'] variable.

	$monthname = $lang['datetime'][date("F", mktime(0,0,0,$month,1,$year))]; 

   	echo "<b><center>$day $monthname $year</center></b></th></tr><tr><Td>";

   	$database = mysql_connect($dbhost, $dbuser, $dbpasswd);
   	mysql_select_db($dbname, $database);
   	$sql = "SELECT * FROM $mysql_tablename WHERE eventspan >= \"$year-$month-$day 00:00:00\" AND stamp <= \"$year-$month-$day 23:59:59\"";
   	if ($calmod != "yes")
   	   {
  	   $user_id = $userdata[user_id];
  	   $sql .= " AND user_id = '$user_id'";
    	   }
	$sql .= " ORDER BY stamp";

   	$query = mysql_query($sql, $database);

	// MOD to deal with sid being passed as GET.
	$url = append_sid($PHP_SELF."?day=".$day."&month=".$month."&year=".$year."&mode=operate");

   	echo "<form method=post action='$url'>
      	<table width=100% cellpadding=2 cellspacing=0 border=0 style=\"border-collapse: expand; border-color=black;\">
      	<tr>
      	<td width='40' class=row2><b><span class=genmed>" . $lang['Select'] . "</span></b></td>
      	<td width=15% class=row2 NOWRAP><b><span class=genmed>" . $lang['Username'] . "</span></b></td>
      	<td width=15% class=row2 NOWRAP><b><span class=genmed>" . $lang['Date'] . "</span></b></td>
      	<td width=15% class=row2 NOWRAP><b><span class=genmed>" . $lang['End_day'] . "</span></b></td>
      	<td width=55% class=row2 NOWRAP><b><span class=genmed>" . $lang['Subject'] . "</span></b></td>
      	</tr>\n";
	$i = 0;
   	while ($row = mysql_fetch_array($query))
   	   {
   	   $zdesc=stripslashes($row[description]);
   	   $zsujet=stripslashes($row[subject]);
	   $bbcode_uid = $row[bbcode_uid];
	   if( $board_config['allow_bbcode'] )
		{
		$zdesc = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($zdesc, $bbcode_uid) : preg_replace("/\:[0-9a-z\:]+\]/si", "]", $zdesc);
		}
   	   echo "<tr>
		<td rowspan='2'><input type=radio name=id value=$row[id]></td>
		<td class=row1 NOWRAP><span class=genmed>$row[username]</span></td>
		<td class=row1 NOWRAP><span class=genmed>". mydateformat($row[stamp], $userdata['user_dateformat']) ."</span></td>
		<td class=row1 NOWRAP><span class=genmed>". mydateformat($row[eventspan], $userdata['user_dateformat'], 1) ."</span></td>
		<td class=row1><span class=genmed>$zsujet</span></td>
		</tr>
		<tr>
		<td colspan='4' class=row1><span class=genmed>$zdesc</span></td>
		</tr>
		<tr>
		<td colspan='5' class=row2><hr width=100% size=1></td>
		</tr>";
   	   $i++;
   	   }
	if($i == 0)
	   {
	   echo "<tr><td><span class=gen>".$lang['No records modify']."</span></td></tr>";
	   }
   	echo "</table><p>";
	echo "<center><SELECT name=action>\n";
	if ($userdata && $userdata[user_id] != '-1' && ($userdata[user_level] == 1 || $calmod))
	   {
	echo "<option value=\"Delete_marked\"> " . $lang['Cal_del_marked']. " </option>\n";
	   }
	echo "<option value=\"Modify_marked\" SELECTED> " . $lang['Cal_mod_marked'] . " </option>
	   </SELECT>\n";
	echo "<br><input type=submit value=\"" . $lang['Submit'] . "\" class=mainoption></center></form>
	   </table>";
	return;
	// end modify
}

function validate()
{
	// Start of MOD function (validate untrusted events)
   	global $PHP_SELF, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action,
		$id, $day, $month, $year, $time, $userdata, $lang, $config_footer, $footer, $calmod, $caluser,
		$endday, $endmonth, $endyear, $usersuggest;

	if ($userdata && $userdata[user_id] != '-1' && ($userdata[user_level] == 1) || ($calmod == 'yes'))
	   {
	   echo "<b><center>".$lang['Validate']."</center></b></th></tr><tr><Td>";
	   switch ($action)
		{
	   	case "validevent":
          	// Validate the selected events.

          	if (!$id)
		   {
		   echo "<span class=gen>". $lang['Cal_must_sel_event'] . "</span></th></tr><tr><Td>\n";
		   break;
		   }
           	// $id is an array where checkboxes
          	while (list($thisid,$value) = each($id))
		   {
		   // echo $thisid; echo $value; exit;
		   if ($value=='yes')
			{
			mysql_query("UPDATE $mysql_tablename SET valid = 'yes' WHERE id = '$thisid'");
			}
		   elseif ($value=='del')
			{
			mysql_query("DELETE FROM $mysql_tablename WHERE id = '$thisid'");
			}
		   echo "<span class=gen>". $lang['Cal_event_validated'] ."</span>";
		   }
		$url = append_sid($PHP_SELF."?month=".$month."&year=".$year);
		echo "<form method=POST action='$url'><input type=submit value=\"" . $lang['Cal_back2cal'] . "\" class=mainoption>
		</form>
		</table>";
		break;


		case "getlist":
		// Get the list of events waiting to be validated and display them for selection

		$database = mysql_connect($dbhost, $dbuser, $dbpasswd);
		mysql_select_db($dbname, $database);
		$sql = "SELECT * FROM $mysql_tablename WHERE valid='no' ORDER BY stamp";
		$query = mysql_query($sql);

		$url = append_sid($PHP_SELF."?mode=validate");

		echo "<form method=post action='$url'>
		<input type='hidden' name='action' value='validevent'>
		<table width=100% cellpadding=2 cellspacing=0 border=0 style=\"border-collapse: expand; border-color=black;\">
		<tr>
		<td width='40' class=row2 NOWRAP><b><span class=genmed>" . $lang['Select'] . "</span></b></td>
		<td width=15% class=row2 NOWRAP><b><span class=genmed>" . $lang['Username'] . "</span></b></td>
		<td width=15% class=row2 NOWRAP><b><span class=genmed>" . $lang['Date'] . "</span></b></td>
		<td width=15% class=row2 NOWRAP><b><span class=genmed>" . $lang['End_day'] . "</span></b></td>
		<td width=55% class=row2 NOWRAP><b><span class=genmed>" . $lang['Subject'] . "</span></b></td>
		</tr>\n";

		$i = 0;
		while ($row = mysql_fetch_array($query))
		   {
		   $zdesc=stripslashes($row[description]);
		   $zsujet=stripslashes($row[subject]);
		   echo "<tr>
		   <td rowspan='2'><select name=id[".$row[id]."]>
		   <option value='hold' SELECTED>Hold</option>
		   <option value='yes'>Accept</option>
		   <option value='del'>Deny</option>
		   </select></td>
		   <td class=row1 NOWRAP><span class=genmed>$row[username]</span></td>
		   <td class=row1 NOWRAP><span class=genmed>". mydateformat($row[stamp], $userdata['user_dateformat']) ."</span></td>
		   <td class=row1 NOWRAP><span class=genmed>". mydateformat($row[eventspan], $userdata['user_dateformat'], 1) ."</span></td>
		   <td class=row1><span class=genmed>$zsujet</span></td>
		   </tr>
		   <tr>
		   <td colspan='4' class=row1><span class=genmed>$zdesc</span></td>
		   </tr>
		   <tr>
		   <td colspan='5' class=row2><hr width=100% size=1></td>
		   </tr>";
		   $i++;
		   }
		if($i == 0)
		   {
		   echo "<tr><td colspan=5><span class=gen>".$lang['No records']."</span></td></tr>";
		   }
		echo "</table><p>";
		echo "<center>\n";
		if ($i >= 1)
		   {
		   echo "<input type=submit value=\"" . $lang['Submit'] . "\" class=mainoption></center>";
		   }
		echo "</form>";
		$url = append_sid($PHP_SELF."?month=".$month."&year=".$year);
		echo "<form method=POST action=$url><input type=submit value=\"" . $lang['Cal_back2cal'] . "\" class=mainoption>
		</form>
		</table>";
		break;
		}
	   }
	else
	   {
	   print ("<span class=gen>". $lang['Cal_delete_event'] ."</span>");
	   }
	return;
}


function operate()
{
   	global $PHP_SELF, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action, $lastday,
		$id, $day, $month, $year, $time, $userdata, $username, $modify, $lang, $config_footer, $footer, $calmod, $caluser,
		$endday, $endmonth, $endyear, $usersuggest, $allowold, $bbcode_uid;
	print("&nbsp;</th></tr><tr><Td>");

	$database = mysql_connect($dbhost, $dbuser, $dbpasswd);
	mysql_select_db($dbname, $database);

	$lastday = 1;
	while (checkdate($month,$lastday,$year))
	   {
	   $lastday++;
	   }
	if ($userdata && $userdata[user_id] != '-1') 
	   {
	   if ($action == 'Delete_marked') { delete_marked(); }
	   if ($action == 'Modify_marked') { modify_marked(); }
	   if ($action == 'Cal_add_event') { cal_add_event(); }
	   if ($action == 'Addsucker') { addsucker($modify); }
	   }
	return;
}

function delete_marked()
{
   	global $PHP_SELF, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action, $lastday,
		$id, $day, $month, $year, $time, $userdata, $lang, $config_footer, $footer, $calmod, $caluser,
		$endday, $endmonth, $endyear, $usersuggest;
	if ($userdata[user_id] != '-1' && ($userdata[user_level] == 1) || ($calmod == 'yes'))
	   {
	   if (!$id)
		{
		echo "<span class=gen>". $lang['Cal_must_sel_event'] . "</span></th></tr><tr><Td>\n";
		operations_footer();
		exit;
		}

	   $query = mysql_query("SELECT username, user_id FROM $mysql_tablename WHERE id = $id");
	   $row = mysql_fetch_array($query);

	   if ( !$REMOTE_USER )
		{
		mysql_query("DELETE FROM $mysql_tablename WHERE id = '$id'");
		echo "<span class=gen>". $lang['Cal_event_delete'] ."</span>";
		}
	   else
		{
		if ( strcmp($row[username], $REMOTE_USER) == 0 )
		   {
		   mysql_query("DELETE FROM $mysql_tablename WHERE id = '$id'");
		   echo "<span class=gen>". $lang['Cal_event_delete'] ."</span>";
		   }
		else
		   {
		   echo "<span class=gen>". $lang['Cal_edit_own_event'] ."</span>";
		   }
		}
	   }
	else
	{
	   print ("<span class=gen>". $lang['Cal_delete_event'] ."</span>");
	}
	operations_footer();
	return;
}


function modify_marked()
{
	global $html_entities_match, $html_entities_replace;
   	global $PHP_SELF, $board_config, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action, $lastday,
		$id, $day, $month, $year, $time, $userdata, $lang, $config_footer, $footer, $calmod, $caluser,
		$endday, $endmonth, $endyear, $usersuggest, $allowold, $bbcode_uid;

	include_once($phpbb_root_path . 'includes/functions_post.'.$phpEx);

	// MOD BBCode vars from templates.
	include($phpbb_root_path . 'calpost_js.php');
	// MOD end BBcode template stuff.

	if ($userdata[user_id] != '-1') 
	   {
	   if (!$id)
		{
		echo "<span class=gen>". $lang['Cal_must_sel_event'] . "</span>";
		operations_footer();
		exit;	   
		}
	   $sql = "SELECT *, RIGHT(stamp, 8) AS thetime, SUBSTRING(stamp FROM 9 FOR 2) AS theday,
		SUBSTRING(eventspan FROM 9 FOR 2) AS theendday,
		SUBSTRING(stamp FROM 6 FOR 2) AS theendmonth,
		SUBSTRING(stamp FROM 1 FOR 4) AS theendyear
		FROM $mysql_tablename WHERE id = '$id'";
	   $query = mysql_query($sql);
	   $row = mysql_fetch_array($query);
	   if ($userdata[user_level] == 1 || $userdata[user_id] == $row[user_id]) 
		{
		$bbcode_uid = $row[bbcode_uid];
		$zdesc = ereg_replace("<br />", "", $row[description]);
		$zdesc = preg_replace("/\:(([a-z0-9]:)?)" . $bbcode_uid . "/si", "", $zdesc);


		$url = append_sid($PHP_SELF."?mode=operate");
		echo "<form method=post name='post' action='$url'>
		<input type=hidden name=id value='$row[id]'>
		<input type=hidden name=bbcode_uid value='$row[bbcode_uid]'>
		<table width=100% cellpadding=2 cellspacing=0 border=0 style=\"border-collapse: expand; border-color=black;\">
		<tr>
		<td><b><span class=genmed>" . $lang['Username'] . "</span></b></td>\n";

		if ( !$REMOTE_USER )
		   {
		   echo "<td><input type=text name=username size=20 value='$row[username]'></td></tr>\n";
		   }
		else
		   {
		   if ( strcmp($REMOTE_USER, $row[user_id]) == 0)
			{
			echo "<td>$REMOTE_USER<input type=hidden name=username value='$REMOTE_USER'></td></tr>\n";
			}
		   else
			{
			echo "<td><span class=gen>" . $lang['Cal_edit_own_event'] . "</span></td></tr>\n
			</table></form>\n";
			operations_footer();
			exit;
			}
		   }

		echo "<tr>
		   <td><b><span class=genmed>" . $lang['Cal_day'] . "</span></b></td>
		   <td><select name=day size=1>";

		for ($i=1; $i<$lastday; $i++)
		   {
		   if ($i == $row[theday])
			{
			echo "<option value=$i selected>$i</option>";
			}
		   else
			{
			echo "<option value=$i>$i</option>";
			}
		   }
		echo "</select><select size=1 name=month>";
		for ($i=1; $i<13; $i++)
		   {
		   // $nm = $lang['months_long'][date('n', mktime(0,0,0,$i,1,$year))-1];
		   // v1.2.1.c Replaced with CVS friendly version following change to $lang['datetime'] variable.

		   $nm = $lang['datetime'][date("F", mktime(0,0,0,$i,1,$year))]; 

		   if ($i == $month)
		   	{
			echo "<option value=$i selected>$nm</option>";
			}
		   else
			{
			echo "<option value=$i>$nm</option>";
			}
		   }
		echo "</select><select size=1 name=year>";
		for ($i=$year-2; $i<$year+5; $i++)
		   {
		   if ($i == $year)
			{
			echo "<option value=$i selected>$i</option>";
			}
		   else
			{
			echo "<option value=$i>$i</option>";
			}
		   }

	   echo "<tr><td><b><span class=genmed>" . $lang['Cal_hour'] . " (hh:mm:ss)</span></b></td>";
	   echo "<td><input type=text name=time value='$row[thetime]'></td></tr>";

	   echo "<tr><td><b><span class=genmed>". $lang['End_day'] . "</span></b></td>
		<td><select name=endday size=1>";
	   for ($i=1; $i<$lastday; $i++)
		{
		if ($i == $row[theendday])
		   {
		   echo "<option value=$i selected>$i</option>";
		   }
		else
		   {
		   echo "<option value=$i>$i</option>";
		   }
		}

	   echo "</select><select size=1 name=endmonth>";
	   for ($i=1; $i<13; $i++)
		{
		// $nm = $lang['months_long'][date('n', mktime(0,0,0,$i,1,$year))-1];
		// v1.2.1.c Replaced with CVS friendly version following change to $lang['datetime'] variable.

		$nm = $lang['datetime'][date("F", mktime(0,0,0,$i,1,$year))]; 

		if ($i == $row[theendmonth])
		   {
		   echo "<option value=$i selected>$nm</option>";
		   }
		else
		   {
		   echo "<option value=$i>$nm</option>";
		   }
		}
	   echo "</select><select size=1 name=endyear>";
	   for ($i=$year-2; $i<$year+5; $i++)
		{
		if ($i == $row[theendyear])
		   {
		   echo "<option value=$i selected>$i</option>";
		   }
		else
		   {
		   echo "<option value=$i>$i</option>";
		   }
		}



		echo "</select></tr>
		   <tr><td><b><span class=genmed>" . $lang['Cal_subject'] . "</span></b></td>
		   <td><input type=text name=subject value='";
		echo stripslashes ($row[subject]);
		echo "'></td></tr>

		   <tr><td><b><span class=genmed>" . $lang['Cal_description'] . "</span></b></td>
		   <td>";

		// MOD add in the BBcode template stuff.
		include($phpbb_root_path . 'calpost.php');

		echo "</table>
		   <input type=hidden name=action value=Addsucker>
		   <input type=hidden name=modify value='Modify'>
		   <input type=submit value=\"" . $lang['Cal_submit_event'] . "\" class=mainoption>
		   </form>\n";
		}
	   else 
		{
		echo "<span class=gen>".$lang['Cal_not_enough_access'] . "</span></th></tr><tr><Td>\n"; 
		}
	   }
	else 
	   {
	   echo "<span class=gen>".$lang['Cal_not_enough_access'] . "</span></th></tr><tr><Td>\n"; 
	   }
	operations_footer();
	return;
}

function cal_add_event()
{
   	global $PHP_SELF, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action,
		$id, $day, $month, $year, $time, $userdata, $lang, $calmod, $caluser, $lastday,
		$endday, $endmonth, $endyear, $usersuggest, $allowold, $bbcode_uid;

	// MOD ver 1.0.8 : Double checks no-ones trying to sneak one through.
	if ((($userdata && $userdata[user_id] != '-1') && ($usersuggest == 'yes')) || ($caluser == 'yes'))
	   {
	   // MOD BBCode vars from templates.
	   include($phpbb_root_path . 'calpost_js.php');
	   // MOD end BBcode template stuff.

	   echo "<span class=gen>". $lang['Cal_add_event'] . "</span></th></tr><tr><Td>\n";
	   $query = mysql_query("SELECT max(id) as id FROM $mysql_tablename");
	   if ($query)
		{
		$result = mysql_fetch_array($query);
		$result["id"]++;
		}
	   else
		{
		$result["id"] = 0;
		}

	   // MOD to deal with sid being passed as GET.
	   $url = append_sid($PHP_SELF."?mode=operate");

	   echo "<form method=post name='post' action='$url'>
		<input type=hidden name=id value=$result[id]>
		<table>
		<tr><td><span class=genmed><b>" . $lang['Username'] . "</b></span></td>\n";

	   if ( !$REMOTE_USER )
		{
		echo "<td><span class=genmed>$userdata[username]</span><input type=hidden name=username size=20 value=\"$userdata[username]\"></td></tr>\n";
		}
	   else
		{
		echo "<td><span class=genmed>$REMOTE_USER</span><input type=hidden name=username value='$REMOTE_USER'></td></tr>\n";
		}

	   echo "<tr><td><b><span class=genmed>". $lang['Cal_day'] . "</span></b></td>
		<td><select name=day size=1>";
	   for ($i=1; $i<$lastday; $i++)
		{
		if ($i == $day)
		   {
		   echo "<option value=$i selected>$i</option>";
		   }
		else
		   {
		   echo "<option value=$i>$i</option>";
		   }
		}

	   echo "</select><select size=1 name=month>";
	   for ($i=1; $i<13; $i++)
		{
		// $nm = $lang['months_long'][date('n', mktime(0,0,0,$i,1,$year))-1];
		// v1.2.1.c Replaced with CVS friendly version following change to $lang['datetime'] variable.

		$nm = $lang['datetime'][date("F", mktime(0,0,0,$i,1,$year))]; 

		if ($i == $month)
		   {
		   echo "<option value=$i selected>$nm</option>";
		   }
		else
		   {
		   echo "<option value=$i>$nm</option>";
		   }
		}
	   echo "</select><select size=1 name=year>";
	   for ($i=$year-2; $i<$year+5; $i++)
		{
		if ($i == $year)
		   {
		   echo "<option value=$i selected>$i</option>";
		   }
		else
		   {
		   echo "<option value=$i>$i</option>";
		   }
		}
	   echo "</select></td></tr>";
	   echo "<tr><td><span class=genmed><b>". $lang['Cal_hour'] . "</b> (hh:mm:ss)</span></td>";
	   echo "<td><input type=text name=time></td></tr>";
	   echo "<tr><td><b><span class=genmed>". $lang['End_day'] . "</span></b></td>
		<td><select name=endday size=1>";
	   for ($i=1; $i<$lastday; $i++)
		{
		if ($i == $day)
		   {
		   echo "<option value=$i selected>$i</option>";
		   }
		else
		   {
		   echo "<option value=$i>$i</option>";
		   }
		}

	   echo "</select><select size=1 name=endmonth>";
	   for ($i=1; $i<13; $i++)
		{
		// $nm = $lang['months_long'][date('n', mktime(0,0,0,$i,1,$year))-1];
		// v1.2.1.c Replaced with CVS friendly version following change to $lang['datetime'] variable.

		$nm = $lang['datetime'][date("F", mktime(0,0,0,$i,1,$year))]; 

		if ($i == $month)
		   {
		   echo "<option value=$i selected>$nm</option>";
		   }
		else
		   {
		   echo "<option value=$i>$nm</option>";
		   }
		}
	   echo "</select><select size=1 name=endyear>";
	   for ($i=$year-2; $i<$year+5; $i++)
		{
		if ($i == $year)
		   {
		   echo "<option value=$i selected>$i</option>";
		   }
		else
		   {
		   echo "<option value=$i>$i</option>";
		   }
		}
	   echo "</select></td></tr>
		<tr><td><span class=genmed><b>" . $lang['Cal_subject'] . "</b></span></td>
		<td><input type=text name=subject></td></tr>
		<tr><td><span class=genmed><b>" . $lang['Cal_description'] . "</b></span></td>
		<td>";
		$zdesc = '';	// clears the description area.
		// MOD add in the BBcode template stuff.
		include($phpbb_root_path . 'calpost.php');

		// echo <textarea wrap=virtual rows=5 cols=50 name=description></textarea>
	   echo	"</td></tr>
		</table>
		<input type=hidden name=action value=Addsucker>
		<input type=submit value=\"" . $lang['Cal_submit_event'] . "\" class=mainoption>
		</form>\n";
	   }
	else 
	   {
	   print ($lang['Cal_must_member']);
	   }
	operations_footer();
	return;
}


function addsucker( $modify='')
{
	global $html_entities_match, $html_entities_replace; 
   	global $PHP_SELF, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action,
		$board_config, $id, $day, $month, $year, $time, $userdata, $username, $modify, $lang, $description, $subject, $calmod, $caluser,
		$endday, $endmonth, $endyear, $usersuggest, $allowold, $bbcode_uid;

	if (($subject =='') || ($description ==''))
	   {
	   // Nothing in the subject line: Reject it.
	   echo "<span class=gen>". $lang['No information'] . "</span></th></tr></table>\n";
	   operations_footer();
	   exit;
	   }
	$currentdate = strftime("%Y%m%d", time());
	$submitdate = strftime("%Y%m%d", mktime (0,0,0,$month,$day,$year));
	$submitenddate = strftime("%Y%m%d", mktime (0,0,0,$endmonth,$endday,$endyear));
	// echo $submitdate." : ".$currentdate; exit;
	if (($currentdate > $submitdate) && ($allowold != 'yes'))
	   {
	   echo "<span class=gen>". $lang['Date before today'] . "</span></th></tr></table>\n";
	   operations_footer();
	   return;
	   }
	if ($submitdate > $submitenddate)
	   {
	   echo "<span class=gen>". $lang['Date before start'] . "</span></th></tr></table>\n";
	   operations_footer();
	   return;
	   }

	include_once($phpbb_root_path . 'includes/functions_post.'.$phpEx);

	if (!$bbcode_uid) { $bbcode_uid = make_bbcode_uid(); }

	// PREPARE MESSAGE
	$description = prepare_message($description,
	   $board_config['allow_html'],
	   $board_config['allow_bbcode'],
	   $board_config['allow_smilies'],
	   $bbcode_uid);

	$description = nl2br($description);
	$description = addslashes($description);
	$subject = addslashes($subject);
	if ($userdata[user_id]) { $userid = $userdata[user_id]; }
	else { $userid = '-1'; }
	$valid = 'no';
	if ($caluser == 'yes')
	   {
	   $valid = 'yes';
	   }

	if ($modify)
	   {
	   ereg_replace("<br />", "", $description);
	   $sql = "UPDATE $mysql_tablename SET stamp='$year-$month-$day $time', subject='$subject', description='$description', eventspan='$endyear-$endmonth-$endday', bbcode_uid='$bbcode_uid' WHERE id = '$id'";
	   }
	else
	   {
	   $sql = "INSERT INTO $mysql_tablename (username, stamp, subject, description, user_id, valid, eventspan, bbcode_uid) VALUES ('$username', '$year-$month-$day $time', '$subject', '$description', '$userid', '$valid', '$endyear-$endmonth-$endday', '$bbcode_uid')";
	   }
	$temp = mysql_query($sql);
	if ($temp != 0)
	   {
	   echo "<span class=gen>" .$lang['Cal_event_add']."</span>";
	   }
	else
	   {
	   echo "<span class=gen>" .$lang['Cal_event_not_add']."</span>";
	   echo mysql_error();
	   }
	operations_footer();
	return;
}

function operations_footer()
{
   	global $PHP_SELF, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action,
		$board_config, $id, $day, $month, $year, $time, $userdata, $lang, $description, $subject, $calmod, $caluser;

	$url = append_sid($PHP_SELF."?month=".$month."&year=".$year);
	echo "<form method=POST action='$url'><input type=submit value=\"" . $lang['Cal_back2cal'] . "\" class=mainoption>
	   </form>
	   </table>";
	return;
}

// End Operations
// End Operations


function display()
{
   	global $PHP_SELF, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action,
		$id, $day, $month, $year, $time, $userdata, $lang, $config_footer, $footer, $calmod, $caluser,
		$endday, $endmonth, $endyear, $usersuggest, $board_config, $bbcode_uid;

	// $monthname = $lang['months_long'][date('n', mktime(0,0,0,$month,1,$year))-1];
	// v1.2.1.c Replaced with CVS friendly version following change to $lang['datetime'] variable.

	$monthname = $lang['datetime'][date("F", mktime(0,0,0,$month,1,$year))]; 




	echo "<b><center>$day $monthname $year</center></b></th></tr>
	   <tr><Td>\n";

	$database = mysql_connect($dbhost, $dbuser, $dbpasswd);
	mysql_select_db($dbname, $database);

	$lastseconds = mktime(0,0,0,$month,$day,$year)-(24*60*60);
        $lastday = date('j', $lastseconds);
        $lastmonth = date('m', $lastseconds);
        $lastyear = date('Y', $lastseconds);

	$nextseconds = mktime(0,0,0,$month,$day,$year)+(24*60*60);
        $nextday = date('j', $nextseconds);
        $nextmonth = date('m', $nextseconds);
        $nextyear = date('Y', $nextseconds);

	$sql = "SELECT * FROM $mysql_tablename WHERE valid = 'yes' AND eventspan >= \"$year-$month-$day 00:00:00\" AND stamp <= \"$year-$month-$day 23:59:59\" ORDER BY stamp";
	$query = mysql_query($sql, $database);

	$check = 0;
	echo "<table cellpadding=2 cellspacing=0 border=0 width=100%>";
	while ($row = mysql_fetch_array($query))
	   {
	   if ($check == 0) 
		{
		echo "<tr><td width=55% class=row2 NOWRAP><span class=genmed><b>" . $lang['Subject'] . "</b></span></td>
		<td width=15% class=row2 NOWRAP><span class=genmed><b>" . $lang['Date'] . "</b></span></td>
		<td width=15% class=row2 NOWRAP><span class=genmed><b>" . $lang['End_day'] . "</b></span></td>
		<td width=15% class=row2 NOWRAP><span class=genmed><b>" . $lang['Author'] . "</b></span></td></tr>\n";
		}
	   $check++;
	   $subject=stripslashes($row[subject]);
	   $zdesc=stripslashes($row[description]);
	   $bbcode_uid = $row[bbcode_uid];
	   if( $board_config['allow_bbcode'] )
		{
		$zdesc = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($zdesc, $bbcode_uid) : preg_replace("/\:[0-9a-z\:]+\]/si", "]", $zdesc);
		}

	   $zdesc = make_clickable($zdesc);
	   echo "<tr><td class=row1><span class=genmed><B>$subject</B></span></td>";
	   echo "<td class=row1 NOWRAP><span class=genmed>". mydateformat($row[stamp], $userdata['user_dateformat']) ."</span></td>";
	   echo "<td class=row1 NOWRAP><span class=genmed>". mydateformat($row[eventspan], $userdata['user_dateformat'], 1) ."</span></td>";
	   echo "<td class=row1 NOWRAP><span class=genmed>$row[username]</span></td></tr>";
	   echo "<tr><td class=row1 colspan=4><span class=genmed>$zdesc</span></td></tr>";
	   echo "<tr><td colspan='4' class=row2><hr width=100% size=1></td></tr>\n";
	   }
	if($check == 0)
	   {
	   echo "<tr><td><span class=gen>".$lang['No events']."</span></td></tr>";
	   }
	echo "</table>\n";
	echo "<center>";
	echo "<table><tr>";
	
	$url = append_sid($PHP_SELF."?day=".$lastday."&month=".$lastmonth."&year=".$lastyear."&mode=display");
	echo "<td><form method=post action='$url'><input type=submit value='<<' class=mainoption>";
	echo "</form></td>\n";

	$url = append_sid($PHP_SELF."?day=".$day."&month=".$month."&year=".$year);
	echo "<td><form method=post action='$url'>";
	echo "<input type=submit value=\"" . $lang['Cal_back2cal'] . "\" class=mainoption>";
	echo "</form></td>\n";

	// MOD to deal with sid being passed as GET.
	$url = append_sid($PHP_SELF."?day=".$nextday."&month=".$nextmonth."&year=".$nextyear."&mode=display");
	echo "<td><form method=post action='$url'>";
	echo "<input type=submit value='>>' class=mainoption>";
	echo "</form></td>\n";
	
	echo "</tr></table>";
	
	if ((($userdata && $userdata[user_id] != '-1') && ($usersuggest == 'yes')) || ($caluser == 'yes'))
	   {
	    
	   echo "<table><tr>";

	   // MOD to deal with sid being passed as GET.
	   $url = append_sid($PHP_SELF."?day=".$day."&month=".$month."&year=".$year."&mode=operate&action=Cal_add_event");

	   echo "<td><form method=post action='$url'>";
	   echo "<input type=submit name='zaction' value=\"" . $lang['Cal_add_event'] . "\" class=mainoption>";
	   echo "</form></td>\n";
	

	   if (($caluser == 'yes') && ($check > 0))
		{
	        $url = append_sid($PHP_SELF."?day=".$day."&month=".$month."&year=".$year."&mode=modify");
		echo "<td><form method=post action=$url>";
		echo "<input type=submit value=\"";
		if ($calmod == 'yes') { echo $lang['Cal_Del_mod']; }
		else { echo $lang['Cal_mod_only']; }
		echo "\" class=mainoption></form></td>\n";
		}
	   if ($calmod == 'yes')
		{
		$url = append_sid($PHP_SELF."?mode=validate&action=getlist");
		echo "<td><form method=post action='$url'";
		echo "<input type=submit value='" . $lang['Validate'] . "' class=mainoption>";
		echo "</form></td>\n";
		}
	   
	   echo "</tr></table>";
	   }
	
	echo "</center>
	   </table>\n";
	return;
}

// End Display
// End Display

// The default display (ie: The main calendar screen)

function defaultview()
{
   	global $PHP_SELF, $phpbb_root_path, $phpEx, $dbhost, $dbuser, $dbpasswd, $dbname, $mysql_tablename, $action, $subjectlen, $cal_dem,
		$board_config, $id, $day, $month, $year, $time, $userdata, $lang, $description, $subject, $calmod, $caluser, $daycolor,
		$endday, $endmonth, $endyear, $usersuggest, $langdays;
	if ($userdata && $userdata[user_id] != '-1') 
	{
		$currentday = create_date("j", time(), $userdata[user_timezone]);
		$currentmonth = create_date("m", time(), $userdata[user_timezone]);
		$currentyear = create_date("Y", time(), $userdata[user_timezone]);
	} 
	else
	{
		$currentday = create_date("j", time(), $board_config['board_timezone']);
		$currentmonth = create_date("m", time(), $board_config['board_timezone']);
		$currentyear = create_date("Y", time(), $board_config['board_timezone']);
	}

	$lastday = 1;
	
	$pt = "*";
	
	$database = mysql_connect($dbhost, $dbuser, $dbpasswd);

	if ($userdata && $userdata[user_id] != '-1') 
	{
		if (!$month)
		{
			$month = create_date("m", time(), $userdata[user_timezone]);
			$year = create_date("Y", time(), $userdata[user_timezone]);
	   	}
	} else
	{
		if (!$month)
	   	{
	   		$month = create_date("m", time(), $board_config['board_timezone']);
	   		$year = create_date("Y", time(), $board_config['board_timezone']);
	   	}
	}

	mysql_select_db($dbname, $database);

	echo "<center><b>";

	//echo $lang['months_long'][date('n', mktime(0,0,0,$month,1,$year))-1];
	// v1.2.1.c Replaced with CVS friendly version following change to $lang['datetime'] variable.

	echo $lang['datetime'][date("m", mktime(0,0,0,$month,1,$year))]; 

	echo " $year  $month </b></center></th></tr><tr><Td>";


	//$firstday = date( 'w', mktime(0,0,0,$month,1,$year));
	$firstday = (date( 'w', mktime(0,0,0,$month,1,$year))-$cal_dem)%7;
	if ($firstday<0)
	   {
	   $firstday = $firstday + 7;
	   }
	while (checkdate($month,$lastday,$year))
	   {
	   $lastday++;
	   }

	$nextmonth = $month+1;
	$nextyear = $year;
	if ($nextmonth == 13)
	   {
	   $nextmonth = 1;
	   $nextyear = $year + 1;
	   }
	$lastmonth = $month-1;
	$lastyear = $year;
	if ($lastmonth == 0)
	   {
	   $lastmonth = 12;
	   $lastyear = $year-1;
	   }

	echo "<table width=100% cellpadding=2 cellspacing=0 border=0 bgcolor='#ffffff' style=\"border-collapse: expand; border-color=black;\">\n";
	echo "<tr><td class=catLeft width=14%><b><span class=genmed>" . $langdays[(0+$cal_dem)%7] . "</span></b></td>\n";
	echo "<td class=catLeft width=14%><b><span class=genmed>" . $langdays[(1+$cal_dem)%7] . "</span></b></td>\n";
	echo "<td class=catLeft width=14%><b><span class=genmed>" . $langdays[(2+$cal_dem)%7] . "</span></b></td>\n";
	echo "<td class=catLeft width=14%><b><span class=genmed>" . $langdays[(3+$cal_dem)%7] . "</span></b></td>\n";
	echo "<td class=catLeft width=14%><b><span class=genmed>" . $langdays[(4+$cal_dem)%7] . "</span></b></td>\n";
	echo "<td class=catLeft width=16%><b><span class=genmed>" . $langdays[(5+$cal_dem)%7] . "</span></b></td>\n";
	echo "<td class=catLeft width=14%><b><span class=genmed>" . $langdays[(6+$cal_dem)%7] . "</span></b></td></tr>\n";
	$rowrow = 1;

	for ($i=0; $i<7; $i++)
	   {
	   if ($i < $firstday)
		{
		echo "<td>&nbsp;</td>";
		}
	   else
		{
		$thisday = ($i+1)-$firstday; 

		if ($currentyear > $year)
		   {
		   echo "<td valign=top>";
		   }
		else if ($currentmonth > $month && $currentyear == $year)
		   {
		   echo "<td valign=top>";
		   }
		else if ($currentmonth == $month && $currentday > $thisday && $currentyear == $year)
		   {
		   echo "<td valign=top bgcolor=$daycolor>";
		   }
		else if ($currentmonth == $month && $currentday == $thisday && $currentyear == $year) 
		   { 
		   echo "<td valign=top class=row3>"; 
		   } 
		else
		   {
		   echo "<td valign=top bgcolor=$daycolor>";
		   }
         	echo "<table border=0 cellspacing=0 cellpadding=0 width=100%><tr>
		   <td height=15 class=row$rowrow>";

		// MOD 1.2.2e (sid)			
		$url = append_sid($PHP_SELF."?day=".$thisday."&month=".$month."&year=".$year."&mode=display");

		echo "<a href='$url' class=topictitle>
		   <b>$thisday</b></a></td></tr><tr><td NOWRAP>\n";
		$query2 = mysql_query("SELECT * FROM $mysql_tablename WHERE valid = 'yes' AND eventspan >= \"$year-$month-$thisday 00:00:00\" AND stamp <= \"$year-$month-$thisday 23:59:59\" ORDER BY stamp");
		for ($j = 0; $j<mysql_num_rows($query2); $j++)
		   {
		   $results = mysql_fetch_array($query2);
		   if ($results["subject"])
 			{
			$subject = stripslashes($results[subject]);
			$full_sujet = $subject;
			$subjectnum = '';
			if ( strlen($subject) > $subjectlen )
 			   {
			   if ((substr($subject,-3,1) == '(') && (substr($subject,-1,1) == ')'))
				{
				// store the number of permits and tack them on the end of the shortened subject
				$subjectnum = substr($subject,-2,1);
				$subject = substr($subject, 0, -3);
				}
			   $subject = substr($subject, 0, $subjectlen);
			   $subject .= '..';
			   }
			if ($subjectnum) { $subject .= ' ('.$subjectnum.')'; }
			// Need to keep the size down
			echo "<acronym title=\"$results[username] " . $lang['Cal_alt_event'] . " $full_sujet\"><span class=gensmall>$pt $subject</span></Acronym><br>\n";
			}
		   }
		if (mysql_num_rows($query2) < 3)
		   {
		   for ($j=0; $j<(2-mysql_num_rows($query2)); $j++)
		   echo "<br>\n";
		   }
		echo "</td></tr></table>\n";
		echo "</td>\n";
		}
	   }

	++$rowrow;
	echo "</tr>\n";
	$nextday = ($i+1)-$firstday;



	for ($j = 0; $j<5; $j++)
	   {
	   echo "<tr>\n";
	   for ($k = 0; $k<7; $k++)
		{
		if ($nextday < $lastday)
		   {
		   if ($currentyear > $year)
			{
			echo "<td valign=top>\n";
			}
		   else if ($currentmonth > $month && $currentyear == $year)
			{
			echo "<td valign=top>\n";
			}
		   else if ($currentmonth == $month && $currentday > $nextday && $currentyear == $year)
			{
			echo "<td valign=top bgcolor=$daycolor>\n";
			}
		   else if (($currentmonth == $month) && ($currentday == $nextday) && ($currentyear == $year)) 
			{
			echo "<td valign=top class=row3>"; 
			} 
		   else
			{
			echo "<td valign=top bgcolor=$daycolor>";
			}
		   echo "<table border=0 cellspacing=0 cellpadding=0 width=100%>
			<tr><td height=15 class=row$rowrow>";

		   // MOD 1.2.2e (sid)			
		   $url = append_sid($PHP_SELF."?day=".$nextday."&month=".$month."&year=".$year."&mode=display");

		   echo "<a href='$url' class=topictitle>$nextday</a></td></tr>
			<tr><td NOWRAP>";
		   $query3 = mysql_query("SELECT * FROM $mysql_tablename WHERE valid = 'yes' AND eventspan >= \"$year-$month-$nextday 00:00:00\" AND stamp <= \"$year-$month-$nextday 23:59:59\" ORDER BY stamp");
		   for ($i = 0; $i<mysql_num_rows($query3)+3; $i++)
			{
			$results2 = mysql_fetch_array($query3);
			if ($results2["subject"])
			   {
			   //echo $results2["subject"]; exit;
			   $subject = stripslashes($results2[subject]);
			   $full_sujet = $subject;
			   $subjectnum = '';
			   if ( strlen($subject) > $subjectlen )
				{
				if ((substr($subject,-3,1) == '(') && (substr($subject,-1,1) == ')'))
				   {
				   // store the number of permits and tack them on the end of the shortened subject
				   $subjectnum = substr($subject,-2,1);
				   $subject = substr($subject, 0, -3);
				   }
				$subject = substr($subject, 0, $subjectlen);
				$subject .= '..';
				}
			   if ($subjectnum) { $subject .= ' ('.$subjectnum.')'; }
			   // Need to keep the size down
			   echo "<acronym title=\"$results2[username] " . $lang['Cal_alt_event'] . " $full_sujet\"><span class=gensmall>$pt $subject</span></Acronym><br>";
			   }
			else if ($i < 2)
			   {
			   echo "<br>";
			   }
			}
			echo "</td></tr></table>\n";
			echo "</td>\n";
			$nextday++;
		   }
		}
		echo "</tr>\n";
		++$rowrow;
		if ($rowrow == '3') {$rowrow = '1';}
	   }

	echo "</table>";

	if ((($userdata && $userdata[user_id] != '-1') && ($usersuggest == 'yes')) || ($caluser == 'yes'))
	   {
	   echo "<center><table><tr>";

	   // MOD 1.2.2e (sid)			
	   $url = append_sid($PHP_SELF."?month=".$lastmonth."&year=".$lastyear);
	   echo "<td><form method=post action=$url>";
	   echo "<input type=submit value='<<' class=mainoption></form></td>\n";

	   // MOD 1.2.2e (sid)			
	   $url = append_sid($PHP_SELF."?month=".$month."&year=".$year."&mode=operate&action=Cal_add_event");
	   echo "<td><form method=post action='$url'>";
	   echo "<input type=submit name=zaction value=\"" . $lang['Cal_add_event'] . "\" class=mainoption>";
	   echo "</form></td>\n";

	   if ($calmod == 'yes')
		{
		// MOD 1.2.2e (sid)			
		$url = append_sid($PHP_SELF."?mode=validate&action=getlist");
		echo "<td><form method=post action='$url'>";
		echo "<input type=submit value=\"" . $lang['Validate'] . "\" class=mainoption></form></td>\n";
		}

	   // MOD 1.2.2e (sid)			
	   $url = append_sid($PHP_SELF."?month=".$nextmonth."&year=".$nextyear);
	   echo "<td><form method=post action=$url>";
	   echo "<input type=submit value='>>' class=mainoption></form></td>";
	   echo "</tr></table>\n";
	   } 
	else 
	   {
	   echo "<center><table><tr>";
	   $url = append_sid($PHP_SELF."?month=".$lastmonth."&year=".$lastyear);
	   echo "<td><form method=post action=$url><input type=submit value='<<' class=mainoption>";
	   echo "</form></td>\n";
	   $url = append_sid($PHP_SELF."?month=".$nextmonth."&year=".$nextyear);
	   echo "<td><form method=post action=$url><input type=submit value='>>' class=mainoption>";
	   echo "</form></td></tr></table>\n";
	   }
	echo "</center></table>";
	return;
}


function calendaruser($test)
{
        global $calusergroup, $table_prefix, $allowreguser, $userdata;
        $caluser = 'no';

	// MOD 1.0.9 : Add in ability for ALL registered members to post.
	if ($userdata && $userdata[user_id] != '-1' && $allowreguser == 'yes') { $caluser = 'yes'; }
	// echo $userdata[user_id]; exit;
	if (!$calusergroup[0]) { return $caluser; }
	
        $sql = "SELECT user_id FROM ".$table_prefix."user_group WHERE (";
        // Read in the Group_id's for the groups that are authorised users.
        $grouplen = sizeof ($calusergroup);
        for ($i = 0; $i <= $grouplen; $i++)
             {
             if ($i == 0) { $sql .= "group_id = '". $calusergroup[$i] ."'"; }
             else { $sql .= " OR group_id = '". $calusergroup[$i] ."'"; }
             }
        $sql .= ") && user_id = '$test' && user_pending = '0'";
        $result = mysql_query($sql);
        //echo $sql; exit;
        $num = mysql_num_rows($result);
        if ($num >= 1) { $caluser = 'yes'; }
        return $caluser;
}

function calendarmod($test)
{
        global $calmodgroup, $table_prefix;
        $calmod = 'no';
	if (!$calmodgroup) { return $calmod; }
        $sql = "SELECT user_id FROM ".$table_prefix."user_group WHERE group_id = '". $calmodgroup ."' && user_id = '$test' && user_pending = '0'";
        $result = mysql_query($sql);
        $num = mysql_num_rows($result);
        if ($num >= 1) { $calmod = 'yes'; }
        return $calmod;
}

function mydateformat($thisdate, $dateformat='d M Y h:i a', $span=0)
{
	global $dateoverride;

	if ($dateoverride) {
		$dateformat = $dateoverride;
		}

	// date comes in as the following: 
	$myr = substr($thisdate, 0, 4);
	$mym = substr($thisdate, 5, 2);
	$myd = substr($thisdate, 8, 2);
	$myh = substr($thisdate, 11, 2);
	$myn = substr($thisdate, 14, 2);
	$mys = substr($thisdate, 17, 2);

	if ($span) {
		// Need to strip out any TIME references so...
		$timerefs = array ('a','A','B','g','G','h','H','i','I','s');
		while (list(,$val) = each ($timerefs))
			{
			$dateformat = ereg_replace($val, "", $dateformat);
			//echo $val.": ".$dateformat."<br>";
			}
		// strip out any characters used for time
		$dateformat = ereg_replace('[:\.]', " ", $dateformat);
		}

	$returndate = date($dateformat, mktime ($myh,$myn,$mys,$mym,$myd,$myr));

	return $returndate;
}

?>