# HappyCGI  phpbb DB
#
# --------------------------------------------------------

#
# ̺  chatsession
#

CREATE TABLE chatsession (
   username varchar(30) NOT NULL,
   lastactive int(11) DEFAULT '0' NOT NULL,
   laststatus varchar(8) NOT NULL,
   UNIQUE username (username)
);
# --------------------------------------------------------

#
# ̺  phpbb_attach
#

CREATE TABLE phpbb_attach (
   attach_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   post_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   privmsgs_id mediumint(8) unsigned DEFAULT '0' NOT NULL
);
# --------------------------------------------------------

#
# ̺  phpbb_attach_config
#

CREATE TABLE phpbb_attach_config (
   config_name varchar(255) NOT NULL,
   config_value varchar(255) NOT NULL,
   PRIMARY KEY (config_name)
);
# --------------------------------------------------------

#
# ̺  phpbb_attach_desc
#

CREATE TABLE phpbb_attach_desc (
   attach_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   attach_filename varchar(255) NOT NULL,
   download_count mediumint(8) unsigned DEFAULT '0' NOT NULL,
   filename varchar(255) NOT NULL,
   comment varchar(60),
   mimetype varchar(60),
   filesize int(20) DEFAULT '0' NOT NULL,
   filetime int(11) DEFAULT '0' NOT NULL,
   PRIMARY KEY (attach_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_attach_extensions
#

CREATE TABLE phpbb_attach_extensions (
   ext_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   extension char(10) NOT NULL,
   PRIMARY KEY (ext_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_attach_typeconfig
#

CREATE TABLE phpbb_attach_typeconfig (
   mime_id mediumint(8) DEFAULT '0' NOT NULL auto_increment,
   type_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   type_string varchar(100) NOT NULL,
   explain_mimetype varchar(100),
   PRIMARY KEY (mime_id),
   KEY type_id_type_string (type_id, type_string)
);
# --------------------------------------------------------

#
# ̺  phpbb_attach_types
#

CREATE TABLE phpbb_attach_types (
   type_id mediumint(8) DEFAULT '0' NOT NULL auto_increment,
   type_name varchar(20) NOT NULL,
   category tinyint(1) DEFAULT '0' NOT NULL,
   allow_type tinyint(1) DEFAULT '0' NOT NULL,
   download_mode tinyint(1) unsigned DEFAULT '1' NOT NULL,
   upload_image varchar(100),
   max_filesize int(20) DEFAULT '0' NOT NULL,
   PRIMARY KEY (type_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_auth_access
#

CREATE TABLE phpbb_auth_access (
   group_id mediumint(8) DEFAULT '0' NOT NULL,
   forum_id smallint(5) unsigned DEFAULT '0' NOT NULL,
   auth_ban tinyint(1) DEFAULT '0' NOT NULL,
   auth_greencard tinyint(1) DEFAULT '0' NOT NULL,
   auth_bluecard tinyint(1) DEFAULT '0' NOT NULL,
   auth_view tinyint(1) DEFAULT '0' NOT NULL,
   auth_read tinyint(1) DEFAULT '0' NOT NULL,
   auth_post tinyint(1) DEFAULT '0' NOT NULL,
   auth_reply tinyint(1) DEFAULT '0' NOT NULL,
   auth_edit tinyint(1) DEFAULT '0' NOT NULL,
   auth_delete tinyint(1) DEFAULT '0' NOT NULL,
   auth_sticky tinyint(1) DEFAULT '0' NOT NULL,
   auth_announce tinyint(1) DEFAULT '0' NOT NULL,
   auth_globalannounce tinyint(1),
   auth_vote tinyint(1) DEFAULT '0' NOT NULL,
   auth_pollcreate tinyint(1) DEFAULT '0' NOT NULL,
   auth_attachments tinyint(1) DEFAULT '0' NOT NULL,
   auth_mod tinyint(1) DEFAULT '0' NOT NULL,
   auth_download tinyint(1) DEFAULT '0' NOT NULL,
   KEY group_id (group_id),
   KEY forum_id (forum_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_banlist
#

CREATE TABLE phpbb_banlist (
   ban_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   ban_userid mediumint(8) DEFAULT '0' NOT NULL,
   ban_ip varchar(8) NOT NULL,
   ban_email varchar(255),
   PRIMARY KEY (ban_id),
   KEY ban_ip_user_id (ban_ip, ban_userid)
);
# --------------------------------------------------------

#
# ̺  phpbb_calendar
#

CREATE TABLE phpbb_calendar (
   id int(11) DEFAULT '0' NOT NULL auto_increment,
   username varchar(255),
   stamp datetime,
   subject varchar(255),
   description blob,
   user_id mediumint(1) DEFAULT '-1' NOT NULL,
   valid char(3) DEFAULT 'no' NOT NULL,
   eventspan date,
   bbcode_uid varchar(10),
   PRIMARY KEY (id)
);
# --------------------------------------------------------

#
# ̺  phpbb_cat_rel_cat_parents
#

CREATE TABLE phpbb_cat_rel_cat_parents (
   cat_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   parent_cat_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (cat_id, parent_cat_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_cat_rel_forum_parents
#

CREATE TABLE phpbb_cat_rel_forum_parents (
   cat_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   parent_forum_id smallint(5) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (cat_id, parent_forum_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_categories
#

CREATE TABLE phpbb_categories (
   cat_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   cat_title varchar(100),
   cat_order mediumint(8) unsigned DEFAULT '0' NOT NULL,
   parent_forum_id smallint(5) unsigned DEFAULT '0' NOT NULL,
   cat_hier_level tinyint(3) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (cat_id),
   KEY cat_order (cat_order)
);
# --------------------------------------------------------

#
# ̺  phpbb_config
#

CREATE TABLE phpbb_config (
   config_name varchar(255) NOT NULL,
   config_value varchar(255) NOT NULL,
   PRIMARY KEY (config_name)
);
# --------------------------------------------------------

#
# ̺  phpbb_disallow
#

CREATE TABLE phpbb_disallow (
   disallow_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   disallow_username varchar(25),
   PRIMARY KEY (disallow_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_favorite_folder
#

CREATE TABLE phpbb_favorite_folder (
   folder_id mediumint(8) DEFAULT '0' NOT NULL auto_increment,
   folder_name varchar(25) NOT NULL,
   owner_id mediumint(8) DEFAULT '0' NOT NULL,
   collections mediumint(8) DEFAULT '0' NOT NULL,
   create_time int(11),
   PRIMARY KEY (folder_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_favorites
#

CREATE TABLE phpbb_favorites (
   favorite_id mediumint(8) DEFAULT '0' NOT NULL auto_increment,
   topic_id mediumint(8) DEFAULT '0' NOT NULL,
   folder_id mediumint(8) DEFAULT '0' NOT NULL,
   user_id mediumint(8) DEFAULT '0' NOT NULL,
   add_time int(11) DEFAULT '0' NOT NULL,
   PRIMARY KEY (favorite_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_forum_prune
#

CREATE TABLE phpbb_forum_prune (
   prune_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   forum_id smallint(5) unsigned DEFAULT '0' NOT NULL,
   prune_days tinyint(4) unsigned DEFAULT '0' NOT NULL,
   prune_freq tinyint(4) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (prune_id),
   KEY forum_id (forum_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_forums
#

CREATE TABLE phpbb_forums (
   forum_id smallint(5) unsigned DEFAULT '0' NOT NULL,
   cat_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   forum_name varchar(150),
   forum_desc text,
   forum_status tinyint(4) DEFAULT '0' NOT NULL,
   forum_order mediumint(8) unsigned DEFAULT '1' NOT NULL,
   forum_posts mediumint(8) unsigned DEFAULT '0' NOT NULL,
   forum_topics mediumint(8) unsigned DEFAULT '0' NOT NULL,
   forum_last_post_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   forum_hier_level tinyint(3) unsigned DEFAULT '0' NOT NULL,
   forum_issub tinyint(1) DEFAULT '0' NOT NULL,
   prune_next int(11),
   prune_enable tinyint(1) DEFAULT '0' NOT NULL,
   auth_greencard tinyint(2) DEFAULT '5' NOT NULL,
   auth_bluecard tinyint(2) DEFAULT '1' NOT NULL,
   auth_ban tinyint(2) DEFAULT '3' NOT NULL,
   auth_view tinyint(2) DEFAULT '0' NOT NULL,
   auth_read tinyint(2) DEFAULT '0' NOT NULL,
   auth_post tinyint(2) DEFAULT '0' NOT NULL,
   auth_reply tinyint(2) DEFAULT '0' NOT NULL,
   auth_edit tinyint(2) DEFAULT '0' NOT NULL,
   auth_delete tinyint(2) DEFAULT '0' NOT NULL,
   auth_sticky tinyint(2) DEFAULT '0' NOT NULL,
   auth_announce tinyint(2) DEFAULT '0' NOT NULL,
   auth_globalannounce tinyint(2) DEFAULT '3' NOT NULL,
   auth_vote tinyint(2) DEFAULT '0' NOT NULL,
   auth_pollcreate tinyint(2) DEFAULT '0' NOT NULL,
   auth_attachments tinyint(2) DEFAULT '0' NOT NULL,
   auth_rate tinyint(2) DEFAULT '-1' NOT NULL,
   auth_download tinyint(2) DEFAULT '0' NOT NULL,
   PRIMARY KEY (forum_id),
   KEY forums_order (forum_order),
   KEY cat_id (cat_id),
   KEY forum_last_post_id (forum_last_post_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_groups
#

CREATE TABLE phpbb_groups (
   group_id mediumint(8) DEFAULT '0' NOT NULL auto_increment,
   group_type tinyint(4) DEFAULT '1' NOT NULL,
   group_name varchar(40) NOT NULL,
   group_description varchar(255) NOT NULL,
   group_moderator mediumint(8) DEFAULT '0' NOT NULL,
   group_single_user tinyint(1) DEFAULT '1' NOT NULL,
   PRIMARY KEY (group_id),
   KEY group_single_user (group_single_user)
);
# --------------------------------------------------------

#
# ̺  phpbb_posts
#

CREATE TABLE phpbb_posts (
   post_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   topic_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   forum_id smallint(5) unsigned DEFAULT '0' NOT NULL,
   poster_id mediumint(8) DEFAULT '0' NOT NULL,
   post_time int(11) DEFAULT '0' NOT NULL,
   post_bluecard tinyint(1) DEFAULT '0' NOT NULL,
   poster_ip varchar(8) NOT NULL,
   post_username varchar(25),
   enable_bbcode tinyint(1) DEFAULT '1' NOT NULL,
   enable_html tinyint(1) DEFAULT '0' NOT NULL,
   enable_smilies tinyint(1) DEFAULT '1' NOT NULL,
   enable_sig tinyint(1) DEFAULT '1' NOT NULL,
   post_edit_time int(11),
   post_edit_count smallint(5) unsigned DEFAULT '0' NOT NULL,
   post_icon tinyint(2) unsigned DEFAULT '1' NOT NULL,
   PRIMARY KEY (post_id),
   KEY forum_id (forum_id),
   KEY topic_id (topic_id),
   KEY poster_id (poster_id),
   KEY post_time (post_time)
);
# --------------------------------------------------------

#
# ̺  phpbb_posts_text
#

CREATE TABLE phpbb_posts_text (
   post_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   bbcode_uid varchar(10) NOT NULL,
   post_subject varchar(60),
   post_text text,
   PRIMARY KEY (post_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_privmsgs
#

CREATE TABLE phpbb_privmsgs (
   privmsgs_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   privmsgs_type tinyint(4) DEFAULT '0' NOT NULL,
   privmsgs_subject varchar(255) DEFAULT '0' NOT NULL,
   privmsgs_from_userid mediumint(8) DEFAULT '0' NOT NULL,
   privmsgs_to_userid mediumint(8) DEFAULT '0' NOT NULL,
   privmsgs_date int(11) DEFAULT '0' NOT NULL,
   privmsgs_ip varchar(8) NOT NULL,
   privmsgs_enable_bbcode tinyint(1) DEFAULT '1' NOT NULL,
   privmsgs_enable_html tinyint(1) DEFAULT '0' NOT NULL,
   privmsgs_enable_smilies tinyint(1) DEFAULT '1' NOT NULL,
   privmsgs_attach_sig tinyint(1) DEFAULT '1' NOT NULL,
   PRIMARY KEY (privmsgs_id),
   KEY privmsgs_from_userid (privmsgs_from_userid),
   KEY privmsgs_to_userid (privmsgs_to_userid)
);
# --------------------------------------------------------

#
# ̺  phpbb_privmsgs_text
#

CREATE TABLE phpbb_privmsgs_text (
   privmsgs_text_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   privmsgs_bbcode_uid varchar(10) DEFAULT '0' NOT NULL,
   privmsgs_text text,
   PRIMARY KEY (privmsgs_text_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_ranks
#

CREATE TABLE phpbb_ranks (
   rank_id smallint(5) unsigned DEFAULT '0' NOT NULL auto_increment,
   rank_title varchar(50) NOT NULL,
   rank_min mediumint(8) DEFAULT '0' NOT NULL,
   rank_special tinyint(1) DEFAULT '0',
   rank_image varchar(255),
   PRIMARY KEY (rank_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_rate_config
#

CREATE TABLE phpbb_rate_config (
   config_name varchar(255) NOT NULL,
   config_value varchar(255) NOT NULL,
   PRIMARY KEY (config_name)
);
# --------------------------------------------------------

#
# ̺  phpbb_rate_results
#

CREATE TABLE phpbb_rate_results (
   user_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   topic_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   rating mediumint(8) unsigned DEFAULT '0' NOT NULL,
   rater_ip char(8) NOT NULL,
   rate_time int(14),
   PRIMARY KEY (user_id, topic_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_search_results
#

CREATE TABLE phpbb_search_results (
   search_id int(11) unsigned DEFAULT '0' NOT NULL,
   session_id varchar(32) NOT NULL,
   search_array text NOT NULL,
   PRIMARY KEY (search_id),
   KEY session_id (session_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_search_wordlist
#

CREATE TABLE phpbb_search_wordlist (
   word_text varchar(50) binary NOT NULL,
   word_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   word_common tinyint(1) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (word_text),
   KEY word_id (word_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_search_wordmatch
#

CREATE TABLE phpbb_search_wordmatch (
   post_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   word_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   title_match tinyint(1) DEFAULT '0' NOT NULL,
   KEY word_id (word_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_sessions
#

CREATE TABLE phpbb_sessions (
   session_id char(32) NOT NULL,
   session_user_id mediumint(8) DEFAULT '0' NOT NULL,
   session_start int(11) DEFAULT '0' NOT NULL,
   session_time int(11) DEFAULT '0' NOT NULL,
   session_ip char(8) DEFAULT '0' NOT NULL,
   session_page int(11) DEFAULT '0' NOT NULL,
   session_logged_in tinyint(1) DEFAULT '0' NOT NULL,
   PRIMARY KEY (session_id),
   KEY session_user_id (session_user_id),
   KEY session_id_ip_user_id (session_id, session_ip, session_user_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_smilies
#

CREATE TABLE phpbb_smilies (
   smilies_id smallint(5) unsigned DEFAULT '0' NOT NULL auto_increment,
   code varchar(50),
   smile_url varchar(100),
   emoticon varchar(75),
   smile_stat mediumint(8) unsigned DEFAULT '0' NOT NULL,
   PRIMARY KEY (smilies_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_themes
#

CREATE TABLE phpbb_themes (
   themes_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   template_name varchar(30) NOT NULL,
   style_name varchar(30) NOT NULL,
   head_stylesheet varchar(100),
   body_background varchar(100),
   body_bgcolor varchar(6),
   body_text varchar(6),
   body_link varchar(6),
   body_vlink varchar(6),
   body_alink varchar(6),
   body_hlink varchar(6),
   tr_color1 varchar(6),
   tr_color2 varchar(6),
   tr_color3 varchar(6),
   tr_class1 varchar(25),
   tr_class2 varchar(25),
   tr_class3 varchar(25),
   th_color1 varchar(6),
   th_color2 varchar(6),
   th_color3 varchar(6),
   th_class1 varchar(25),
   th_class2 varchar(25),
   th_class3 varchar(25),
   td_color1 varchar(6),
   td_color2 varchar(6),
   td_color3 varchar(6),
   td_class1 varchar(25),
   td_class2 varchar(25),
   td_class3 varchar(25),
   fontface1 varchar(50),
   fontface2 varchar(50),
   fontface3 varchar(50),
   fontsize1 tinyint(4),
   fontsize2 tinyint(4),
   fontsize3 tinyint(4),
   fontcolor1 varchar(6),
   fontcolor2 varchar(6),
   fontcolor3 varchar(6),
   span_class1 varchar(25),
   span_class2 varchar(25),
   span_class3 varchar(25),
   img_size_poll smallint(5) unsigned,
   img_size_privmsg smallint(5) unsigned,
   PRIMARY KEY (themes_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_themes_name
#

CREATE TABLE phpbb_themes_name (
   themes_id smallint(5) unsigned DEFAULT '0' NOT NULL,
   tr_color1_name char(50),
   tr_color2_name char(50),
   tr_color3_name char(50),
   tr_class1_name char(50),
   tr_class2_name char(50),
   tr_class3_name char(50),
   th_color1_name char(50),
   th_color2_name char(50),
   th_color3_name char(50),
   th_class1_name char(50),
   th_class2_name char(50),
   th_class3_name char(50),
   td_color1_name char(50),
   td_color2_name char(50),
   td_color3_name char(50),
   td_class1_name char(50),
   td_class2_name char(50),
   td_class3_name char(50),
   fontface1_name char(50),
   fontface2_name char(50),
   fontface3_name char(50),
   fontsize1_name char(50),
   fontsize2_name char(50),
   fontsize3_name char(50),
   fontcolor1_name char(50),
   fontcolor2_name char(50),
   fontcolor3_name char(50),
   span_class1_name char(50),
   span_class2_name char(50),
   span_class3_name char(50),
   PRIMARY KEY (themes_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_topics
#

CREATE TABLE phpbb_topics (
   topic_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   forum_id smallint(8) unsigned DEFAULT '0' NOT NULL,
   topic_title char(60) NOT NULL,
   topic_poster mediumint(8) DEFAULT '0' NOT NULL,
   topic_time int(11) DEFAULT '0' NOT NULL,
   topic_views mediumint(8) unsigned DEFAULT '0' NOT NULL,
   topic_replies mediumint(8) unsigned DEFAULT '0' NOT NULL,
   topic_status tinyint(3) DEFAULT '0' NOT NULL,
   topic_vote tinyint(1) DEFAULT '0' NOT NULL,
   topic_type tinyint(3) DEFAULT '0' NOT NULL,
   topic_first_post_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   topic_last_post_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   topic_moved_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   topic_icon tinyint(2) unsigned DEFAULT '1' NOT NULL,
   PRIMARY KEY (topic_id),
   KEY forum_id (forum_id),
   KEY topic_moved_id (topic_moved_id),
   KEY topic_status (topic_status),
   KEY topic_type (topic_type)
);
# --------------------------------------------------------

#
# ̺  phpbb_topics_watch
#

CREATE TABLE phpbb_topics_watch (
   topic_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   user_id mediumint(8) DEFAULT '0' NOT NULL,
   notify_status tinyint(1) DEFAULT '0' NOT NULL,
   KEY topic_id (topic_id),
   KEY user_id (user_id),
   KEY notify_status (notify_status)
);
# --------------------------------------------------------

#
# ̺  phpbb_user_group
#

CREATE TABLE phpbb_user_group (
   group_id mediumint(8) DEFAULT '0' NOT NULL,
   user_id mediumint(8) DEFAULT '0' NOT NULL,
   user_pending tinyint(1),
   KEY group_id (group_id),
   KEY user_id (user_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_users
#

CREATE TABLE phpbb_users (
   user_id mediumint(8) DEFAULT '0' NOT NULL auto_increment,
   user_active tinyint(1) DEFAULT '1',
   username varchar(25) NOT NULL,
   user_password varchar(32) NOT NULL,
   user_session_time int(11) DEFAULT '0' NOT NULL,
   user_session_page smallint(5) DEFAULT '0' NOT NULL,
   user_lastvisit int(11) DEFAULT '0' NOT NULL,
   user_regdate int(11) DEFAULT '0' NOT NULL,
   user_level tinyint(4) DEFAULT '0',
   user_posts mediumint(8) unsigned DEFAULT '0' NOT NULL,
   user_timezone float(10,2) DEFAULT '0.00' NOT NULL,
   user_style tinyint(4),
   user_lang varchar(255),
   user_dateformat varchar(14) DEFAULT 'Y m d H:i' NOT NULL,
   user_new_privmsg smallint(5) unsigned DEFAULT '0' NOT NULL,
   user_unread_privmsg smallint(5) unsigned DEFAULT '0' NOT NULL,
   user_last_privmsg int(11) DEFAULT '0' NOT NULL,
   user_emailtime int(11),
   user_viewemail tinyint(1),
   user_attachsig tinyint(1),
   user_allowhtml tinyint(1) DEFAULT '1',
   user_allowbbcode tinyint(1) DEFAULT '1',
   user_allowsmile tinyint(1) DEFAULT '1',
   user_allowavatar tinyint(1) DEFAULT '1' NOT NULL,
   user_allow_pm tinyint(1) DEFAULT '1' NOT NULL,
   user_allow_viewonline tinyint(1) DEFAULT '1' NOT NULL,
   user_notify tinyint(1) DEFAULT '1' NOT NULL,
   user_notify_pm tinyint(1) DEFAULT '1' NOT NULL,
   user_popup_pm tinyint(1) DEFAULT '0' NOT NULL,
   user_post_sort tinyint(2) DEFAULT '0' NOT NULL,
   user_rank int(11) DEFAULT '0',
   user_avatar varchar(100),
   user_avatar_type tinyint(4) DEFAULT '0' NOT NULL,
   user_email varchar(255),
   user_icq varchar(15),
   user_website varchar(100),
   user_from varchar(100),
   user_sig text,
   user_sig_bbcode_uid varchar(10),
   user_aim varchar(255),
   user_yim varchar(255),
   user_msnm varchar(255),
   user_occ varchar(100),
   user_interests varchar(255),
   user_actkey varchar(32),
   user_newpasswd varchar(32),
   user_lastlogon int(11) DEFAULT '0',
   user_gender tinyint(4) DEFAULT '0' NOT NULL,
   user_birthday int(11) DEFAULT '999999' NOT NULL,
   user_next_birthday_greeting int(11) DEFAULT '0' NOT NULL,
   user_points mediumint(8) unsigned DEFAULT '0' NOT NULL,
   user_realname varchar(30),
   user_reg_number varchar(15),
   user_tel_myhouse varchar(15),
   user_tel_office varchar(15),
   user_handphone varchar(15),
   PRIMARY KEY (user_id),
   KEY user_session_time (user_session_time)
);
# --------------------------------------------------------

#
# ̺  phpbb_vote_desc
#

CREATE TABLE phpbb_vote_desc (
   vote_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   topic_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   vote_text text NOT NULL,
   vote_start int(11) DEFAULT '0' NOT NULL,
   vote_length int(11) DEFAULT '0' NOT NULL,
   PRIMARY KEY (vote_id),
   KEY topic_id (topic_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_vote_results
#

CREATE TABLE phpbb_vote_results (
   vote_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   vote_option_id tinyint(4) unsigned DEFAULT '0' NOT NULL,
   vote_option_text varchar(255) NOT NULL,
   vote_result int(11) DEFAULT '0' NOT NULL,
   KEY vote_option_id (vote_option_id),
   KEY vote_id (vote_id)
);
# --------------------------------------------------------

#
# ̺  phpbb_vote_voters
#

CREATE TABLE phpbb_vote_voters (
   vote_id mediumint(8) unsigned DEFAULT '0' NOT NULL,
   vote_user_id mediumint(8) DEFAULT '0' NOT NULL,
   vote_user_ip char(8) NOT NULL,
   KEY vote_id (vote_id),
   KEY vote_user_id (vote_user_id),
   KEY vote_user_ip (vote_user_ip)
);
# --------------------------------------------------------

#
# ̺  phpbb_words
#

CREATE TABLE phpbb_words (
   word_id mediumint(8) unsigned DEFAULT '0' NOT NULL auto_increment,
   word char(100) NOT NULL,
   replacement char(100) NOT NULL,
   PRIMARY KEY (word_id)
);
# --------------------------------------------------------

#
# ̺  shoutbox
#

CREATE TABLE shoutbox (
   id int(11) DEFAULT '0' NOT NULL auto_increment,
   name varchar(30) NOT NULL,
   shout varchar(255) NOT NULL,
   url varchar(100) NOT NULL,
   timestamp int(10) unsigned DEFAULT '0' NOT NULL,
   ipaddress text NOT NULL,
   PRIMARY KEY (id)
);

    