<?php 
/////////////////////////////////////////////////////////// 
// MOD Name:  Last X Post 
// 
//  Authors: 
//       Retro  <unknown@unkown> 
//       Martin <phpbb@websnail.net> 
//       John B. Abela <abela@phpbb.com> 
//       Paul Campbell <paulca@iol.ie> 
// 
/////////////////////////////////////////////////////////// 
// DESCRIPTION: 
//       This file will display the most recent X posts 
//       in any file on your server. You can either 
//       place this code in a seperate file and INCLUDE 
//       it, or place this code directly into an existing 
//       file. 
// 
/////////////////////////////////////////////////////////// 
// VERSION HISTORY: 
//       11/01/2002 - Paul Campbell - 
//         Fixed Show sticky / announce bug 
//         Added show forum name to template vars 
//       12/26/2001 - Paul Campbell - 
//         Added PHPBB2 database abstraction 
//         Added template compatability 
//         Complied to PHPBB2 coding standard with vars 
//       12/26/2001 - John B. Abela - 
//             Inital Documentation And Formating 
//             Streamlined Code, 
//             CHANGED: 
//                 DISTINCT topic.topic_title, 
//             TO: 
//                 DISTINCT ptxt.post_subject 
//             as I felt it was a better method of displaying. 
// 
//       12/10/2001 - Martin - 
//             Substantial Upgrade Including 'Time-Zone' 
// 
//       12/08/2001 - Retro - 
//             Initial Release - Edited From phpBB1 MOD 
//             origianlly written by John B. Abela & Frank F. 
// 
/////////////////////////////////////////////////////////// 
// NOTES: 
//       There is a quark in this code that allows the 
//       same post to be shown multiple times. 
//       If you can fix it, please do, and add your name 
//       to the top of this file (and remove this 'note') 
//       I (John B. Abela) can't seem to find it... but 
//       that is probably because I'm not all that good 
//       at table-joins and all that stuff <grin> 
// 
/////////////////////////////////////////////////////////// 
// SET PATHS 
/////////////////////////////////////////////////////////// 
// 
define('IN_PHPBB', true); 

if (!$userdata) 
{ 
// connect to phpbb 
include_once($phpbb_root_path . 'extension.inc'); 
include_once($phpbb_root_path . 'common.'.$phpEx); 
include_once($phpbb_root_path . 'includes/bbcode.'.$phpEx); 
include_once($phpbb_root_path . 'includes/functions.'.$phpEx); 

// Start session management 
// 
if(!$userdata) 
   { 
$userdata = session_pagestart($user_ip, PAGE_INDEX, $session_length); 
init_userprefs($userdata); 
   } 
} 


$phpbb_root_path = "$DOCUMENT_ROOT/";   //- Note: trailing forward slash 
$phpbb_url_path = '/';  //- Note: trailing forward slash ! 
// 
/////////////////////////////////////////////////////////// 
// Last X Post Options 
/////////////////////////////////////////////////////////// 
// 
$post_number = "100";  // How Many Posts To Display 
$title_preview = "100"; // number of characters to display of title 
$post_preview = "100"; // number of characters to display of message preview 
$time_difference = 0;// Time difference between server and board time 

$show_sticky = 0; // show sticky posts or not, 1 is on, 0 is off. 
$show_announce = 0; // show announcements or not, 1 is on, 0 is off. 

include($phpbb_root_path . 'includes/page_header.'.$phpEx); 

/////////////////////////////////////////////////////////// 
//   Assign Template Vars ( remove if you've included page_header.php ) 
/////////////////////////////////////////////////////////// 
   $template->assign_vars(array( 
      "T_TH_COLOR2" => "#".$theme['th_color2'], 
      "T_FONTFACE1" => $theme['fontface1'], 
      "T_FONTCOLOR1" => "#".$theme['fontcolor1'], 
      "T_FONTSIZE1" => $theme['fontsize1'], 
      "POST_NUMBER" => $post_number, 
      "PHPBB_URL_PATH" => $phpbb_url_path 

      )); 
/////////////////////////////////////////////////////////// 
// CONSTRUCT SQL STATEMENT 
/////////////////////////////////////////////////////////// 
// 

$sql = "SELECT t.*, u.username, u.user_id, u2.username as user2, u2.user_id as id2, p.post_time,pt.post_text, f.forum_id,f.forum_name, p.post_username 
   FROM " . TOPICS_TABLE . " t, " . USERS_TABLE . " u, " . POSTS_TABLE . " p, " . USERS_TABLE . " u2, " . FORUMS_TABLE . " f, " . POSTS_TEXT_TABLE . " pt 
   WHERE t.topic_poster = u.user_id 
   AND p.forum_id = f.forum_id 
      AND p.post_id = t.topic_last_post_id 
      AND p.poster_id = u2.user_id 
   AND p.post_id = pt.post_id"; 
if($show_announce == 0) 
   { 
      $sql .= " 
      AND t.topic_type <> " . POST_ANNOUNCE ; 
   } 
if($show_sticky == 0) 
   { 
      $sql .= " 
      AND t.topic_type <> " . POST_STICKY ; 
   } 
      $sql .= "$only_sql 
   ORDER BY t.topic_type DESC, p.post_time DESC 
   LIMIT 0, $post_number"; 

// 
// 
// 
/////////////////////////////////////////////////////////// 
// SETTING/VARIABLES/STUFF 
/////////////////////////////////////////////////////////// 
// 


if( !$t_result = $db->sql_query($sql) ) 
{ 
   message_die(GENERAL_ERROR, "Couldn't obtain topic information", "", __LINE__, __FILE__, $sql); 
} 
$total_topics = $db->sql_numrows($t_result); 
while( $t_row = $db->sql_fetchrow($t_result) ) 
   { 
      $topic_rowset[] = $t_row; 
   } 

// 
// Dump the page 
// 
if( $total_topics ) 
{ 
   // 
   // First get announcements 
   // 
   while( $ta_row = $db->sql_fetchrow($ta_result) ) 
   { 
      $topic_rowset[] = $ta_row; 
   } 
   // 
   // Now get everything else 
   // 
   while( $t_row = $db->sql_fetchrow($t_result) ) 
   { 
      $topic_rowset[] = $t_row; 
   } 

   for($i = 0; $i < $total_topics; $i++) 
   { 
      if( count($orig_word) ) 
      { 
         $topic_title = preg_replace($orig_word, $replacement_word, $topic_rowset[$i]['topic_title']); 
       
      } 
      else 
      { 
         $topic_title = $topic_rowset[$i]['topic_title']; 
      } 

   $forum_title = $topic_rowset[$i]['forum_name']; 

      $topic_type = $topic_rowset[$i]['topic_type']; 

      if( $topic_type == POST_ANNOUNCE ) 
      { 
         $topic_type = $lang['Topic_Announcement'] . " "; 
      } 
      else if( $topic_type == POST_STICKY ) 
      { 
         $topic_type = $lang['Topic_Sticky'] . " "; 
      } 
      else 
      { 
         $topic_type = "";        
      } 
if( $topic_rowset[$i]['topic_vote'] ) 
      { 
         $topic_type .= $lang['Topic_Poll'] . " "; 
      } 
        
      $topic_id = $topic_rowset[$i]['topic_id']; 
   $forum_id = $topic_rowset[$i]['forum_id']; 

      $replies = $topic_rowset[$i]['topic_replies']; 
if( ( $replies + 1 ) > $board_config['posts_per_page'] ) 
      { 
         $goto_page = " [ <img src=\"" . $phpbb_url_path . $images['icon_minipost'] . "\" alt=\"" . $lang['Goto_page'] . "\" title=\"" . $lang['Goto_page'] . "\" border=0/>" . $lang['Goto_page'] . ": "; 

         $times = 1; 
         for($j = 0; $j < $replies + 1; $j += $board_config['posts_per_page']) 
         { 
            if( $times > 4 ) 
            { 
               if( $j + $board_config['posts_per_page'] >= $replies + 1 ) 
               { 
                  $goto_page .= " ... <a href=\"" . $phpbb_url_path . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $topic_id . "&amp;start=$j") . "\">$times</a>"; 
               } 
            } 
            else 
            { 
               if( $times != 1 ) 
               { 
                  $goto_page .= ", "; 
               } 
               $goto_page .= "<a href=\"" . $phpbb_url_path . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=" . $topic_id . "&amp;start=$j") . "\">$times</a>"; 
            } 
            $times++; 
         } 
         $goto_page .= " ] "; 
      } 
      else 
      { 
         $goto_page = ""; 
      } 

$view_topic_url = append_sid( $phpbb_url_path . "viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id"); 
$view_forum_url = append_sid( $phpbb_url_path . "viewforum.$phpEx?" . POST_FORUM_URL . "=$forum_id"); 

      $topic_poster = ( $topic_rowset[$i]['user_id'] != ANONYMOUS ) ? "<a href=\"" . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $topic_rowset[$i]['user_id']) . "\">" : ""; 
      $topic_poster .= ( $topic_rowset[$i]['user_id'] != ANONYMOUS ) ? $topic_rowset[$i]['username'] : ( ( $topic_rowset[$i]['post_username'] != "" ) ? $topic_rowset[$i]['post_username'] : $lang['Guest'] ); 
      $topic_poster .= ( $topic_rowset[$i]['user_id'] != ANONYMOUS ) ? "</a>" : ""; 

//change time according to server time / local time 
$topic_rowset[$i]['post_time'] = $topic_rowset[$i]['post_time'] + ($time_difference * 3600); 
      $last_post_time = create_date($board_config['default_dateformat'], $topic_rowset[$i]['post_time'], $board_config['board_timezone']); 

      $last_post = $last_post_time . "<br />"; 
      $last_post .= ( $topic_rowset[$i]['id2'] == ANONYMOUS ) ? ( ($topic_rowset[$i]['post_username'] != "" ) ? $topic_rowset[$i]['post_username'] . " " : $lang['Guest'] . " " ) : "<a href=\"" . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "="  . $topic_rowset[$i]['id2']) . "\">" . $topic_rowset[$i]['user2'] . "</a> "; 
      $last_post .= "<a href=\"" . append_sid("viewtopic.$phpEx?"  . POST_POST_URL . "=" . $topic_rowset[$i]['topic_last_post_id']) . "#" . $topic_rowset[$i]['topic_last_post_id'] . "\"><img src=\"" . $images['icon_latest_reply'] . "\" alt=\"" . $lang['View_latest_post'] . "\" title=\"" . $lang['View_latest_post'] . "\" border=\"0\" /></a>"; 

      $views = $topic_rowset[$i]['topic_views']; 
        
      $row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2']; 
      $row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2']; 

   $post_text = $topic_rowset[$i]['post_text']; 

   $template->assign_block_vars("recent_posts", array( 
         "FORUM_ID" => $forum_id, 
         "TOPIC_ID" => $topic_id, 
         "FOLDER" => $folder_image, 
         "TOPIC_POSTER" => $topic_poster, 
         "GOTO_PAGE" => $goto_page, 
         "REPLIES" => $replies, 
         "NEWEST_POST_IMG" => $newest_post_img, 
         "TOPIC_TITLE" => $topic_title, 
       "FORUM_TITLE" => $forum_title, 
      "DISPLAY_FORUM" => substr ( $forum_title, 0, $title_preview ) . '...', 
      "DISPLAY_TITLE" =>   substr ( $topic_title, 0, $title_preview ) . '...', 
         "TOPIC_TYPE" => $topic_type, 
         "VIEWS" => $views, 
         "LAST_POST" => $last_post, 
         "ROW_COLOR" => $row_color, 
         "ROW_CLASS" => $row_class, 
      "POST_TEXT" => substr ( $post_text, 0, $post_preview ) . '...', 

      "U_VIEW_FORUM" => $view_forum_url, 
         "U_VIEW_TOPIC" => $view_topic_url, 

         "LAST_POST_TIME" => $last_post_time 

          


          
         ) 
      ); 
    
} 



          
} 



$template->set_filenames(array( 

   "recent_posts" => "recent.tpl"

)); 


// 
// Parse the page and print 
// 

$template->pparse("recent_posts"); 



          
//} 

   include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 

?> 