<?php 
######################################################## 
## Mod Title:   recent activity of public forums 
## Mod Version: 1.0.0 
## Author:      Roman Malarev 
## Email:       roman@malarev.com 
######################################################## 
## Description: 
## Shows 10 topics with the public access 
## (even unregistered users can read messages) 
## with the most recent messages. 
## 
## Everything comes from templates - so the table looks 
## like tables in your forum. 
######################################################## 
## Limitations: 
## 1) Works with MySQL only 
## 2) Not multilanguage in title - there is no corresponding 
## values at language/lang_<language>/lang_main.php language file 
######################################################## 
## Ideas: 
## Feel free to write your ideas about future of this 
## MOD to me.  
######################################################## 
// Added with changes in Security for PhpBB2. 
define('IN_PHPBB', true); 

if (!$userdata) 
{ 
// connect to phpbb 
include_once($phpbb_root_path . 'extension.inc'); 
include_once($phpbb_root_path . 'common.'.$phpEx); 
include_once($phpbb_root_path . 'includes/bbcode.'.$phpEx); 
include_once($phpbb_root_path . 'includes/functions.'.$phpEx); 
// Start session management 
// 
if(!$userdata) 
   { 
$userdata = session_pagestart($user_ip, PAGE_INDEX, $session_length); 
init_userprefs($userdata); 
   } 
} 

// ADDED ver 1.0.7 (Tablename standardised) 
if (!$mysql_tablename) { 
   $mysql_tablename = $table_prefix . $tablename; 
   } 
// END ADDED 

// MOD ver 1.2.1d 
// Interim days id to help with transfer to $lang['datetime'] format. 
// DO NOT CHANGE THESE!!!!!!!!!!!!!!!! 
$langdays[0] = $lang['datetime']['Sunday']; 
$langdays[1] = $lang['datetime']['Monday']; 
$langdays[2] = $lang['datetime']['Tuesday']; 
$langdays[3] = $lang['datetime']['Wednesday']; 
$langdays[4] = $lang['datetime']['Thursday']; 
$langdays[5] = $lang['datetime']['Friday']; 
$langdays[6] = $lang['datetime']['Saturday']; 
// End change for 1.2.1d 

// Make sure there's a Default for $daycolor 
if(!$daycolor) { $daycolor = '#FFFFFF'; } 

$test = $userdata[user_id]; 

// MOD 1.1.0 

if ( $userdata['session_logged_in'] ) 
   { 
   $lvd = sprintf($lang['You_last_visit'], create_date($board_config['default_dateformat'], $userdata['user_lastvisit'],  $board_config['board_timezone'])); 
   } 
else 
   { 
   $lvd = "Not Logged In"; 
   } 

$page_title = "ֱ  "; 
include($phpbb_root_path . 'includes/page_header.'.$phpEx); 

$active_topics_sql='SELECT a.topic_id,a.topic_title, d.forum_name, a.topic_replies, b.user_id, b.username, a.topic_last_post_id, c.post_time 
FROM '.TOPICS_TABLE .' a, '.USERS_TABLE .'  b, '.POSTS_TABLE.' c, '.FORUMS_TABLE.' d  
where a.topic_last_post_id=c.post_id and b.user_id=c.poster_id 
and d.forum_id=a.forum_id 
and d.auth_read=0 
ORDER BY topic_last_post_id DESC 
LIMIT 1000'; 
$active_topics = $db->sql_query($active_topics_sql); 

$forum_index = sprintf($lang['Forum_Index'], $board_config['sitename']); 
$forum_index_link = append_sid("index.".$phpEx); 

echo " 
<table width=100% cellspacing=2 cellpadding=2 border=0> 
  <tr> 
   <td align=left valign=bottom nowrap><span class=nav><a href=".$forum_index_link." class=nav>".$forum_index."</a></span></td> 
  </tr> 
</table> 
   <table width=\"100%\" cellpadding=\"4\" cellspacing=\"1\" border=\"0\" class=\"forumline\"> 
   <tr> 
    <th class=\"thCornerL\" colspan=\"4\" align=\"center\">".$recent_title."</th> 
   </tr> 
   <tr> 
    <td class=\"catLeft\" width=\"50%\" height=\"28\" align=\"center\"><span class=\"nav\">"   . $lang['Topic']   . "</span></td> 
    <td class=\"catLeft\" height=\"28\" align=\"center\"><span class=\"nav\">"   . $lang['Forum']   . "</span></td> 
    <td class=\"catLeft\" height=\"28\" align=\"center\" nowrap=\"nowrap\"><span class=\"nav\">&nbsp;" . $lang['Last_Post']  . "&nbsp;</span></td>"; 

while ($line = mysql_fetch_array($active_topics)) 
  { 
  $lastpost=create_date($board_config['default_dateformat'], $line['post_time'], $board_config['board_timezone']); 
  $lastpost .= '&nbsp; &nbsp;<a href="' .append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "="  . $line['user_id']) . '">' . $line['username'] . '</a> '; 
  $lastpost .= '<a href="' .append_sid("viewtopic.$phpEx?"  . POST_POST_URL . "=" . $line['topic_last_post_id']) . '#' . $line['topic_last_post_id'] . '"><img src="' .$images['icon_latest_reply'] . '" border="0" alt="' . $lang['View_latest_post'] . '" title="' . $lang['View_latest_post'] . '" /></a>'; 
  echo "<tr> 
    <td class=\"row1\" align=\"left\"><span class=\"topictitle\"><a href=\"viewtopic.php?t=" . $line['topic_id'] . "\"  class=\"topictitle\">" . $line['topic_title'] . "</a><span class=\"maroon\">&nbsp;(" . $line['topic_replies'] . ")</span></span></td> 
    <td class=\"row2\" align=\"left\"><span class=\"name\">".$line['forum_name']."</span></td> 
    <td class=\"row2\" align=\"left\" nowrap=\"nowrap\"><span class=\"postdetails\"> &nbsp; &nbsp; ".$lastpost."</span></td> 
  </tr>"; 
  } 

echo "</table>"; 

include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 

?> 

